// DECALS EXTENSION
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require
layout(early_fragment_tests) in;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _691
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1672
{
    int _m0;
    int _m1;
};

struct _1675
{
    int _m0;
    int _m1;
};

struct _1775
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2572
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3347
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4041
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _723_725
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _725;

layout(set = 2, binding = 0, std140) uniform _829_831
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _831;

layout(set = 1, binding = 0, std140) uniform _1017_1019
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _1019;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1677_1679
{
    _1675 _m0[];
} _1679;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1750_1752
{
    uint _m0[];
} _1752;

layout(set = 0, binding = 15, std140) uniform _1780_1782
{
    vec4 _m0[4096];
} _1782;

layout(set = 0, binding = 16, std140) uniform _1800_1802
{
    vec4 _m0[4096];
} _1802;

layout(set = 0, binding = 17, std140) uniform _1852_1854
{
    vec4 _m0[4096];
} _1854;

layout(set = 0, binding = 19, std140) uniform _2576_2578
{
    vec4 _m0[4096];
} _2578;

layout(set = 0, binding = 20, std140) uniform _2615_2617
{
    vec4 _m0[4096];
} _2617;

layout(set = 0, binding = 21, std140) uniform _2684_2686
{
    vec4 _m0[3072];
} _2686;

layout(set = 0, binding = 23, std140) uniform _3351_3353
{
    vec4 _m0[4095];
} _3353;

layout(set = 0, binding = 25, std140) uniform _4045_4047
{
    vec4 _m0[4096];
} _4047;

layout(push_constant, std430) uniform _4383_4385
{
    int _m0;
    int _m1;
} _4385;

layout(set = 3, binding = 3) uniform TEXTURE_2D _856[8];
layout(set = 0, binding = 2) uniform sampler _863;
layout(set = 3, binding = 2) uniform TEXTURE_2D _904[8];
layout(set = 0, binding = 3) uniform sampler _908;
layout(set = 3, binding = 0) uniform TEXTURE_2D _918[8];
layout(set = 0, binding = 4) uniform sampler _922;
layout(set = 3, binding = 1) uniform TEXTURE_2D _932[8];
layout(set = 0, binding = 5) uniform sampler _936;
layout(set = 3, binding = 7) uniform TEXTURE_2D _945[8];
layout(set = 0, binding = 6) uniform sampler _949;
layout(set = 3, binding = 4) uniform TEXTURE_2D _957[8];
layout(set = 0, binding = 7) uniform sampler _961;
layout(set = 3, binding = 6) uniform TEXTURE_2D _969[8];
layout(set = 0, binding = 8) uniform sampler _973;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1227;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1236;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1292;
layout(set = 0, binding = 12, r32f) uniform writeonly image2D _1547;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2074;
layout(set = 0, binding = 22) uniform SAMPLER_2D _2910;
layout(set = 0, binding = 24) uniform sampler2DShadow _3673;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4186;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4382[8];

layout(location = 2) in vec4 _705;
layout(location = 5) in vec4 _712;
layout(location = 3) in vec4 _715;
layout(location = 4) in vec4 _738;
layout(location = 14) flat in uvec3 _790;
layout(location = 15) in vec4 _793;
layout(location = 6) in vec4 _1006;
layout(location = 0) out vec4 _4340;
layout(location = 1) out vec4 _4348;
layout(location = 2) out vec4 _4356;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

vec4 _116(SAMPLER_2D _112, vec2 _113, vec2 _114, vec2 _115)
{
    return TEXTURE_GRAD(_112, _113, _114, _115);
}

vec4 _109(SAMPLER_2D _107, vec2 _108)
{
    return SAMPLE_TEXTURE(_107, _108);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _141(float _137, vec4 _138, float _139, bool _140)
{
    float _546 = _138.w / (_137 + _138.z);
    return _546 * _139;
}

vec3 _146(vec3 _144, bool _145)
{
    vec3 _559 = (_144 * 2.0) - vec3(1.0);
    float _576 = (1.0 - (_559.x * _559.x)) - (_559.y * _559.y);
    _559.z = sqrt(_10(_576));
    if (_145 == false)
    {
        _559.z = -_559.z;
    }
    return _559;
}

vec3 _153(vec3 _151, mat3 _152)
{
    return normalize(vec3(dot(_151, _152[0]), dot(_151, _152[1]), dot(_151, _152[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _88(uint _87)
{
    return unpackUnorm4x8(_87).wzyx;
}

vec4 _101(uvec2 _100)
{
    return vec4(float((_100.x >> uint(16)) & 65535u), float(_100.x & 65535u), float((_100.y >> uint(16)) & 65535u), float(_100.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _64(float _63)
{
    return _63 * ((_63 * ((_63 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _91(uint _90)
{
    return vec4(float((_90 >> uint(24)) & 255u), float((_90 >> uint(16)) & 255u), float((_90 >> uint(8)) & 255u), float(_90 & 255u));
}

vec3 _67(vec3 _66)
{
    float _275 = _66.x;
    vec3 _274;
    _274.x = _64(_275);
    float _281 = _66.y;
    _274.y = _64(_281);
    float _287 = _66.z;
    _274.z = _64(_287);
    return _274;
}

vec4 _70(vec4 _69)
{
    vec3 _297 = _69.xyz;
    vec4 _296 = vec4(_67(_297), 1.0);
    float _305 = _69.w;
    _296.w = _64(_305);
    return _296;
}

float _81(float _80)
{
    return (step(0.0, _80) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _95(uint _94)
{
    return vec3(float((_94 >> uint(21)) & 2047u), float((_94 >> uint(10)) & 2047u), float(_94 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _220 = abs(_60) >= abs(_58);
    bool _228;
    if (_220)
    {
        _228 = abs(_60) >= abs(_59);
    }
    else
    {
        _228 = _220;
    }
    if (_228)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _73(float _72)
{
    return exp2(_72);
}

vec3 _119(uint _118)
{
    uint _420 = _118;
    vec4 _419 = _88(_420);
    float _431 = (_419.w * 255.0) - 128.0;
    return _419.xyz * _73(_431);
}

float _78(float _76, float _77)
{
    return pow(_76, _77);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _124(vec3 _122, float _123)
{
    float _443 = 50.0 * dot(_122, vec3(0.33329999446868896484375));
    float _436 = _10(_443);
    float _452 = 1.0 - _123;
    float _455 = _10(_452);
    float _456 = 5.0;
    vec3 _460 = _122 + ((vec3(_436) - _122) * _78(_455, _456));
    return _16(_460);
}

vec3 _132(vec3 _127, vec3 _128, vec3 _129, vec3 _130, float _131)
{
    vec3 _464 = normalize(_128 + _129);
    float _469 = 1.0 - (_131 * 0.800000011920928955078125);
    _469 *= _469;
    _469 *= _469;
    float _480 = _469 * _469;
    float _488 = dot(_127, _464);
    float _484 = _10(_488);
    float _490 = ((_484 * _484) * (_480 - 1.0)) + 1.0;
    _490 = _480 / ((_490 * _490) + 9.9999999392252902907785028219223e-09);
    float _509 = dot(_127, _128);
    float _505 = (_10(_509) * (1.0 - _469)) + _469;
    float _520 = dot(_127, _129);
    float _516 = (_10(_520) * (1.0 - _469)) + _469;
    _490 /= (((4.0 * _505) * _516) + 9.9999999392252902907785028219223e-09);
    vec3 _538 = _130;
    float _540 = dot(_129, _464);
    return _124(_538, _540) * _490;
}

vec2 _157(vec2 _156)
{
    return (vec2(1.0) - abs(_156.yx)) * vec2((_156.x >= 0.0) ? 1.0 : (-1.0), (_156.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _162(inout vec3 _160, bool _161)
{
    _160 /= vec3((abs(_160.x) + abs(_160.y)) + abs(_160.z));
    vec2 _643;
    if (_160.z >= 0.0)
    {
        _643 = _160.xy;
    }
    else
    {
        vec2 _649 = _160.xy;
        _643 = _157(_649);
    }
    _160 = vec3(_643.x, _643.y, _160.z);
    if (_161)
    {
        vec2 _664 = (_160.xy * 0.5) + vec2(0.5);
        _160 = vec3(_664.x, _664.y, _160.z);
    }
    return _160.xy;
}

float _84(float _83)
{
    return sqrt(_83);
}

float _165(float _164)
{
    float _674 = abs(_164);
    float _671 = _84(_674);
    float _678;
    if (_164 > 0.0)
    {
        _678 = _671;
    }
    else
    {
        _678 = -_671;
    }
    return (_678 * 0.5) + 0.5;
}

void main()
{
    _691 _693 = _691(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _693._m15 = _705;
    _693._m16 = gl_FragCoord;
    vec3 _711 = vec3(_712.zw, _715.w);
    _693._m14 = _725._m0.xyz + _711;
    vec3 _733 = normalize(_715.xyz);
    vec3 _737 = normalize(_738.xyz);
    vec3 _742 = normalize(cross(_733, _737) * sign(_738.w));
    _693._m17 = mat3(vec3(_737.x, _742.x, _733.x), vec3(_737.y, _742.y, _733.y), vec3(_737.z, _742.z, _733.z));
    _693._m13 = normalize(-_711);
    uint _780 = 0u;
    vec4 _781 = vec4(0.0);
    vec4 _782 = vec4(0.0);
    vec4 _783 = vec4(0.0);
    vec4 _784 = vec4(0.0);
    vec4 _785 = vec4(0.0);
    uvec3 _788 = _790;
    vec3 _792 = _793.xyz;
    bool _799 = _788.y == 65535u;
    bool _805;
    if (_799)
    {
        _805 = _788.z == 65535u;
    }
    else
    {
        _805 = _799;
    }
    bool _796 = _805;
    bool _806 = !_796;
    bool _809 = _788.z != 65535u;
    uint _813 = _788.x & 7u;
    uint _824;
    if (_725._m1.x == 0.0)
    {
        _824 = _813;
    }
    else
    {
        vec4 _832 = _831._m3;
        uvec4 _828 = _44(_832);
        uint _836 = _828[_813 / 2u];
        uint _841 = 16u * (_813 & 1u);
        _824 = (_836 >> _841) & 65535u;
    }
    uint _850 = _824;
    float _852 = SAMPLE_TEXTURE(SAMPLER_2D(_856[_850], _863), _705.zw).x;
    float _881 = pow(_852, 0.125) - 0.800000011920928955078125;
    vec2 _870 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_881) / 0.20000000298023223876953125));
    vec2 _889 = dFdx(_705.zw) * _870.x;
    vec2 _896 = dFdy(_705.zw) * _870.y;
    vec2 _903 = TEXTURE_GRAD(SAMPLER_2D(_904[_850], _908), _705.zw, _889, _896).yx;
    vec3 _917 = SAMPLE_TEXTURE(SAMPLER_2D(_918[_850], _922), _705.zw).xyz;
    vec3 _929 = vec3(0.039999999105930328369140625);
    _929 = SAMPLE_TEXTURE(SAMPLER_2D(_932[_850], _936), _705.zw).xyz;
    float _943 = 1.0;
    float _944 = SAMPLE_TEXTURE(SAMPLER_2D(_945[_850], _949), _705.zw).x;
    float _956 = SAMPLE_TEXTURE(SAMPLER_2D(_957[_850], _961), _705.zw).x;
    vec3 _968 = SAMPLE_TEXTURE(SAMPLER_2D(_969[_850], _973), _705.zw).xyz;
    _783 = vec4(_917.x, _917.y, _917.z, _783.w);
    _783.w = _903.y;
    _784 = vec4(_929.x, _929.y, _929.z, _784.w);
    _784.w = _956;
    _785 = vec4(_785.x, _903.x, _785.z, _903.y);
    _781.x = _944;
    _781.y = _943;
    _781.z = _956;
    _781.w = _852;
    _782 = vec4(_968.x, _968.y, _968.z, _782.w);
    vec3 _1005 = _1006.xyz;
    _693._m10 = (((vec3(_781.x * _781.x) * _1005) * _1019._m0.xyz) * _1019._m1.xxx) * mix(_783.xyz, vec3(1.0), vec3(_1019._m0.w));
    _693._m10 *= vec3(_725._m2.x);
    uint _1044 = 0u;
    _693._m15.x = (_693._m15.x * _1019._m3.x) + _1019._m3.z;
    _693._m15.y = (_693._m15.y * _1019._m3.y) + _1019._m3.w;
    float _1063 = _725._m3.z;
    float _1066 = _725._m4.z;
    vec2 _1069 = _693._m15.xy * _1063;
    vec2 _1075 = dFdx(_1069) / vec2(float(gl_FragmentSizeNV.x));
    vec2 _1084 = dFdy(_1069) / vec2(float(gl_FragmentSizeNV.y));
    vec2 _1093 = _1075;
    vec2 _1095 = _1075;
    float _1092 = _29(_1093, _1095);
    vec2 _1099 = _1084;
    vec2 _1101 = _1084;
    float _1098 = _29(_1099, _1101);
    float _1104 = 0.5 * log2(max(_1092, _1098));
    float _1110 = 0.5 * log2(min(_1092, _1098));
    float _1116 = _1104 - min(_1066, _1104 - _1110);
    float _1124 = _1116;
    float _1126 = _725._m3.y;
    float _1129 = _725._m4.y;
    uvec2 _1132 = uvec2(_693._m15.xy * _1126);
    uint _1139 = uint(min(_725._m4.w, max(0.0, _1116) + _1129));
    uint _1148 = uint(_725._m3.x);
    _1044 = _1132.x & 255u;
    _1044 |= ((_1132.y & 255u) << uint(8));
    _1044 |= ((_1132.x >> uint(8)) << uint(16));
    _1044 |= ((_1132.y >> uint(8)) << uint(24));
    _1044 |= (_1139 << uint(19));
    _1044 |= (_1148 << uint(27));
    vec3 _1240;
    if (_725._m5.y != 0.0)
    {
        float _1188 = fract(_1124);
        float _1191 = 0.375;
        float _1193 = 0.625;
        bool _1200;
        float _1201;
        float _1204;
        if (_1188 <= _1191)
        {
            _1200 = false;
            _1201 = _1124 - 0.5;
            _1204 = 0.0;
        }
        else
        {
            if (_1188 >= _1193)
            {
                _1200 = false;
                _1201 = _1124 + 0.5;
                _1204 = 0.0;
            }
            else
            {
                _1200 = true;
                _1201 = _1124 - 0.5;
                _1204 = _1124 + 0.5;
            }
        }
        vec4 _1219 = vec4(_693._m15.x, _693._m15.y, 0.0, _1201);
        vec2 _1226 = TEXTURE_LOD(_1227, _1219.xy, _1219.w).xy;
        vec4 _1235 = SAMPLE_TEXTURE(_1236, _1226);
        _1240.x = (_693._m15.x * _1235.x) + _1235.z;
        _1240.y = (_693._m15.y * (_1235.x * _725._m6.x)) + _1235.w;
        _1240.z = _1235.y;
        vec2 _1266 = (dFdx(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1240.z;
        vec2 _1279 = (dFdy(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1240.z;
        vec2 _1293 = _1240.xy;
        vec2 _1296 = _1266;
        vec2 _1298 = _1279;
        vec3 _1301 = _116(_1292, _1293, _1296, _1298).xyz;
        _781 = vec4(_1301.x, _1301.y, _1301.z, _781.w);
        vec2 _1304 = _1240.xy;
        vec3 _1308 = _109(_1292, _1304).xyz;
        _781 = vec4(_1308.x, _1308.y, _1308.z, _781.w);
        if (_1200)
        {
            vec4 _1314 = vec4(_693._m15.x, _693._m15.y, 0.0, _1204);
            vec2 _1321 = TEXTURE_LOD(_1227, _1314.xy, _1314.w).xy;
            vec4 _1329 = SAMPLE_TEXTURE(_1236, _1321);
            _1240.x = (_693._m15.x * _1329.x) + _1329.z;
            _1240.y = (_693._m15.y * (_1329.x * _725._m6.x)) + _1329.w;
            _1240.z = _1329.y;
            vec2 _1357 = (dFdx(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1240.z;
            vec2 _1370 = (dFdy(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1240.z;
            vec2 _1384 = _1240.xy;
            vec2 _1387 = _1357;
            vec2 _1389 = _1370;
            vec3 _1392 = _116(_1292, _1384, _1387, _1389).xyz;
            vec4 _1383;
            _1383 = vec4(_1392.x, _1392.y, _1392.z, _1383.w);
            vec2 _1395 = _1240.xy;
            vec3 _1399 = _109(_1292, _1395).xyz;
            _1383 = vec4(_1399.x, _1399.y, _1399.z, _1383.w);
            float _1402 = 0.0;
            float _1403 = 0.375;
            float _1408 = (_1188 - _1403) * 4.0;
            _1402 = _10(_1408);
            vec3 _1416 = mix(_781.xyz, _1383.xyz, vec3(_1402));
            _1383 = vec4(_1416.x, _1416.y, _1416.z, _1383.w);
        }
    }
    else
    {
        vec4 _1420 = vec4(_693._m15.x, _693._m15.y, 0.0, _1124 - 0.5);
        vec2 _1428 = TEXTURE_LOD(_1227, _1420.xy, _1420.w).xy;
        vec4 _1436 = SAMPLE_TEXTURE(_1236, _1428);
        _1240.x = (_693._m15.x * _1436.x) + _1436.z;
        _1240.y = (_693._m15.y * (_1436.x * _725._m6.x)) + _1436.w;
        _1240.z = _1436.y;
        vec2 _1464 = (dFdx(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1240.z;
        vec2 _1477 = (dFdy(_693._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1240.z;
        vec2 _1490 = _1240.xy;
        vec2 _1493 = _1464;
        vec2 _1495 = _1477;
        vec3 _1498 = _116(_1292, _1490, _1493, _1495).xyz;
        _781 = vec4(_1498.x, _1498.y, _1498.z, _781.w);
        vec2 _1501 = _1240.xy;
        vec3 _1505 = _109(_1292, _1501).xyz;
        _781 = vec4(_1505.x, _1505.y, _1505.z, _781.w);
    }
    vec2 _1508 = vec2(160.0, 90.0);
    vec2 _1512 = _1508 * _725._m7.zw;
    vec2 _1519 = (gl_FragCoord.xy * _725._m7.zw) * _1508;
    bool _1533 = fract(_1519.x) < _1512.x;
    bool _1542;
    if (_1533)
    {
        _1542 = fract(_1519.y) < _1512.y;
    }
    else
    {
        _1542 = _1533;
    }
    if (_1542)
    {
        uint _1551 = _1044;
        imageStore(_1547, ivec2(_1519), vec4(_35(_1551), 0.0, 0.0, 0.0));
    }
    _780 = _1044;
    _693._m0 = _783.xyz;
    _693._m2 = _784.xyz;
    _693._m1 = _782.xyz;
    _693._m9 = _781.xyz;
    _693._m3 = _781.w;
    _693._m6 = _785.wyz;
    uint _1575 = 8u;
    float _1576 = 16.0;
    float _1578 = 8.0;
    float _1580 = 24.0;
    vec2 _1589 = _693._m16.xy * _725._m7.xy;
    vec3 _1582;
    _1582 = vec3(_1589.x, _1589.y, _1582.z);
    _1582.y = 1.0 - _1582.y;
        // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
    _1582.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1602 = floor(_1582.xy * vec2(_1576, _1578));
    _1582 = vec3(_1602.x, _1602.y, _1582.z);
    float _1606 = _693._m16.z;
    vec4 _1609 = _725._m8;
    float _1612 = 1.0;
    bool _1613 = false;
    float _1605 = _141(_1606, _1609, _1612, _1613);
    float _1615 = log2(max(1.0, _1605 / _725._m9.z)) * _725._m9.w;
    _1582.z = min(_1580 - 1.0, floor(_1615));
    uint _1631 = uint((_1582.x + (_1582.y * _1576)) + ((_1582.z * _1576) * _1578));
    bool _1647 = true;
    vec3 _1648 = _693._m6;
    bool _1651 = _1647;
    _693._m7 = _146(_1648, _1651);
    vec3 _1655 = _693._m7;
    mat3 _1658 = _693._m17;
    _693._m6 = _153(_1655, _1658);
    uint _1663 = 0u;
    uint _1664 = 0u;
    uint _1665 = 0u;
    uint _1666 = 0u;
    uint _1667 = 0u;
    uint _1668 = 0u;
    int _1670 = 256;
    _1672 _1674;
    _1674._m0 = _1679._m0[_1631]._m0;
    _1674._m1 = _1679._m0[_1631]._m1;
    int _1688 = _1674._m0 & (~(_1674._m0 >> 31));
    int _1697 = _1674._m1 & (~(_1674._m1 >> 31));
    _1663 = uint((_1688 >> 16) * _1670);
    _1664 = _1663 + uint(_1697 & 255);
    _1665 = _1663;
    _1666 = _1665 + uint((_1697 >> 8) & 255);
    _1667 = _1663;
    _1668 = _1667 + uint((_1697 >> 16) & 255);
    vec3 _1730 = dFdx(_693._m14);
    vec3 _1734 = dFdy(_693._m14);
    uint _1738 = _1665;
    _1775 _1777;
    vec3 _2131;
    float _2264;
    while (_1738 < _1666)
    {
        uint _1748 = _1752._m0[_1738];
        uint _1757 = (_1748 >> uint(12)) & 4095u;
        uint _1763 = _1757;
        if (_1763 >= _1757)
        {
            _1738++;
        }
        int _1772 = 2;
        int _1773 = 2;
        int _1774 = 2;
        _1777._m0 = _1782._m0[(uint(_1772) * _1763) + 0u];
        _1777._m1 = _1782._m0[(uint(_1772) * _1763) + 1u];
        _1777._m2 = _1802._m0[(uint(_1773) * _1763) + 0u];
        float _1816 = _1802._m0[(uint(_1773) * _1763) + 1u].x;
        _1777._m3.x = _39(_1816);
        float _1826 = _1802._m0[(uint(_1773) * _1763) + 1u].y;
        _1777._m3.y = _39(_1826);
        float _1836 = _1802._m0[(uint(_1773) * _1763) + 1u].z;
        _1777._m4.x = _39(_1836);
        float _1846 = _1802._m0[(uint(_1773) * _1763) + 1u].w;
        _1777._m4.y = _39(_1846);
        float _1860 = _1854._m0[(uint(_1774) * _1763) + 0u].x;
        _1777._m5.x = _39(_1860);
        float _1870 = _1854._m0[(uint(_1774) * _1763) + 0u].y;
        _1777._m5.y = _39(_1870);
        float _1880 = _1854._m0[(uint(_1774) * _1763) + 0u].z;
        _1777._m6 = _39(_1880);
        float _1890 = _1854._m0[(uint(_1774) * _1763) + 0u].w;
        _1777._m7 = _39(_1890);
        float _1900 = _1854._m0[(uint(_1774) * _1763) + 1u].x;
        _1777._m8 = _39(_1900);
        float _1910 = _1854._m0[(uint(_1774) * _1763) + 1u].y;
        _1777._m9 = _39(_1910);
        float _1920 = _1854._m0[(uint(_1774) * _1763) + 1u].z;
        _1777._m10 = _39(_1920);
        float _1931 = _1854._m0[(uint(_1774) * _1763) + 1u].w;
        _1777._m11 = _39(_1931);
        vec4 _1936 = _1777._m0;
        vec4 _1939 = _1777._m2;
        vec4 _1942 = _1777._m1;
        vec4 _1945 = vec4(_693._m14, 1.0);
        vec3 _1952 = vec3(dot(_1945, _1936), dot(_1945, _1942), dot(_1945, _1939));
        float _1963 = 0.0039215688593685626983642578125;
        float _1965 = _1952.x;
        float _1968 = _1952.y;
        float _1971 = _1952.z;
        bool _1976 = _55(_1965, _1968, _1971) <= _1963;
        bool _1993;
        if (!_1976)
        {
            float _1980 = _1952.x;
            float _1983 = _1952.y;
            float _1986 = _1952.z;
            _1993 = _50(_1980, _1983, _1986) >= (1.0 - _1963);
        }
        else
        {
            _1993 = _1976;
        }
        if (_1993)
        {
            continue;
        }
        uint _1997 = _1777._m11;
        bool _2001 = _1575 != 0u;
        bool _2008;
        if (_2001)
        {
            _2008 = (_1997 & 512u) != 0u;
        }
        else
        {
            _2008 = _2001;
        }
        bool _2021;
        if (!_2008)
        {
            bool _2013 = _1575 == 0u;
            bool _2020;
            if (_2013)
            {
                _2020 = (_1997 & 1024u) != 0u;
            }
            else
            {
                _2020 = _2013;
            }
            _2021 = _2020;
        }
        else
        {
            _2021 = _2008;
        }
        if (_2021)
        {
            continue;
        }
        vec2 _2025 = vec2(dot(_1730, _1936.xyz), dot(_1730, _1942.xyz));
        vec2 _2035 = vec2(dot(_1734, _1936.xyz), dot(_1734, _1942.xyz));
        float _2045 = 1.0;
        float _2046 = 1.0;
        vec3 _2047 = vec3(0.5, 0.5, 1.0);
        vec3 _2049 = vec3(0.0, 0.0, 1.0);
        uint _2050 = _1777._m7;
        uint _2054 = _1777._m9;
        vec4 _2053 = _88(_2054);
        uvec2 _2059 = _1777._m5;
        vec4 _2058 = _101(_2059);
        vec2 _2063 = _2025 * _2058.xy;
        vec2 _2068 = _2035 * _2058.xy;
        vec2 _2083 = (_1952.xy * _2058.xy) + _2058.zw;
        vec2 _2084 = _2063;
        vec2 _2086 = _2068;
        vec4 _2073 = _116(_2074, _2083, _2084, _2086);
        vec2 _2089 = (_2073.xy * 2.0) - vec2(1.0);
        float _2099 = 1.0 - dot(_2089, _2089);
        _2047 = vec3(_2089, sqrt(_10(_2099)));
        _2049 = _2047;
        _2045 = _2073.z;
        float _2108 = _2073.w;
        _2046 = _64(_2108);
        bool _2115 = _2046 <= (4.0 * _1963);
        bool _2122;
        if (_2115)
        {
            _2122 = _2053.w <= _1963;
        }
        else
        {
            _2122 = _2115;
        }
        if (_2122)
        {
            continue;
        }
        _2047 = _2049;
        if ((_1997 & 128u) != 0u)
        {
            _2131 = vec3(-_2047.x, -_2047.y, _2047.z);
        }
        else
        {
            _2131 = _2047;
        }
        _2047 = _2131;
        uint _2146 = _1777._m8;
        uint _2150 = _2146;
        float _2149 = 1.0 + (_91(_2150).w * 0.062745101749897003173828125);
        uint _2158 = _2050;
        float _2157 = _88(_2158).z;
        uint _2163 = _2146;
        vec3 _2162 = _88(_2163).xyz;
        float _2176 = _2149 - (_2149 * abs((_1952.z * 2.0) - 1.0));
        _2046 *= _10(_2176);
        float _2180 = _2046;
        if ((_2050 & 1u) != 0u)
        {
            vec3 _2187 = _2162;
            _2162 = vec3(0.0);
            uvec2 _2190 = _1777._m3;
            vec4 _2189 = _101(_2190);
            vec2 _2194 = _2025 * _2189.xy;
            vec2 _2199 = _2035 * _2189.xy;
            vec2 _2213 = (_1952.xy * _2189.xy) + _2189.zw;
            vec2 _2214 = _2194;
            vec2 _2216 = _2199;
            vec4 _2204 = _116(_2074, _2213, _2214, _2216);
            vec4 _2219 = _2204;
            _2204 = _70(_2219);
            _2162 = _2204.xyz;
            float _2231 = (_2204.w - _1963) / (1.0 - _1963);
            _2180 = _10(_2231);
            _2162 *= _2187;
        }
        vec3 _2236 = normalize(vec3(_693._m17[0].z, _693._m17[1].z, _693._m17[2].z));
        float _2245 = dot(_2236, normalize(_1939.xyz));
        float _2251 = _2245;
        vec2 _2256 = _2047.xy * _81(_2251);
        _2047 = vec3(_2256.x, _2256.y, _2047.z);
        if ((_1997 & 16384u) != 0u)
        {
            float _2269 = abs(_2245);
            _2264 = _10(_2269);
        }
        else
        {
            float _2272 = _2245;
            _2264 = _10(_2272);
        }
        float _2259 = _2264;
        float _2276 = ((_2259 * _2180) * _2053.w) * _2157;
        _693._m10 += (_2053.xyz * (_2276 * 64.0));
        uint _2295 = _1777._m10;
        uint _2299 = _2295;
        vec4 _2298 = _88(_2299);
        if ((_2050 & 2u) != 0u)
        {
            uvec2 _2308 = _1777._m4;
            vec4 _2307 = _101(_2308);
            vec2 _2312 = _2025 * _2307.xy;
            vec2 _2317 = _2035 * _2307.xy;
            vec2 _2330 = (_1952.xy * _2307.xy) + _2307.zw;
            vec2 _2331 = _2312;
            vec2 _2333 = _2317;
            _2298 = _116(_2074, _2330, _2331, _2333);
            _2298 *= _2298;
        }
        if ((_2050 & 32u) != 0u)
        {
            uint _2346 = _2050;
            float _2345 = _88(_2346).x;
            uint _2351 = _2050;
            float _2350 = _91(_2351).y;
            float _2357 = _2345;
            float _2355 = mix(_2350, 0.0, _10(_2357));
            float _2366 = _2045 - (_2355 / 255.0);
            float _2361 = float(_10(_2366) > 0.0);
            _2046 *= _2361;
        }
        float _2373 = _2046 * _2259;
        uint _2377 = _1777._m6;
        uint _2381 = _2377;
        vec4 _2386 = _88(_2381) * _2373;
        vec4 _2380 = _22(_2386);
        _693._m11 = max(_693._m11, _2380.x);
        _693._m0 = mix(_693._m0, _2162, _2380.xxx);
        _693._m2 = mix(_693._m2, _2298.xyz, _2380.yyy);
        vec3 _2409 = _2236;
        vec3 _2419 = _1936.xyz + (_2409 * dot(_1936.xyz, _2409));
        _1936 = vec4(_2419.x, _2419.y, _2419.z, _1936.w);
        vec3 _2430 = _1942.xyz + (_2409 * dot(_1942.xyz, _2409));
        _1942 = vec4(_2430.x, _2430.y, _2430.z, _1942.w);
        _2047 = ((normalize(_1936.xyz) * _2047.x) + (normalize(_1942.xyz) * _2047.y)) + (_2409 * _2047.z);
        if ((_1997 & 256u) != 0u)
        {
            vec3 _2457 = mix(_2236, _2047, _2380.www);
            float _2463 = dot(_2457, _2236);
            _2047 = (_693._m6 * _2463) + ((_2457 - (_2236 * _2463)) * dot(_693._m6, _2236));
        }
        else
        {
            if ((_1997 & 64u) != 0u)
            {
                _2047 = mix(mix(_693._m6, _2236, vec3(_2373)), _2047, _2380.www);
            }
            else
            {
                _2047 = mix(_693._m6, _2047, _2380.www);
            }
        }
        _693._m6 = normalize(_2047);
        _693._m3 = mix(_693._m3, _2298.w, _2380.z);
    }
    vec3 _2517 = vec3(0.0);
    _2517 = _693._m9 * _725._m10.x;
    float _2527;
    if (dot(_693._m10, vec3(1.0)) > 0.0)
    {
        _2527 = -_693._m3;
    }
    else
    {
        _2527 = _693._m3;
    }
    _693._m3 = _2527;
    _693._m18 = _2517;
    _693._m19 = _2517;
    uint _2543 = _1663;
    _2572 _2574;
    vec3 _2871;
    float _2960;
    float _2978;
    _3347 _3349;
    uint _3470;
    _3347 _3493;
    while (_2543 < _1664)
    {
        uint _2553 = _1752._m0[_2543];
        uint _2557 = _2553 & 4095u;
        uint _2560 = _2557;
        if (_2560 >= _2557)
        {
            _2543++;
        }
        int _2569 = 4;
        int _2570 = 4;
        int _2571 = 3;
        _2574._m0 = _2578._m0[(uint(_2569) * _2560) + 0u].xyz;
        float _2593 = _2578._m0[(uint(_2569) * _2560) + 0u].w;
        _2574._m1 = _39(_2593);
        _2574._m2 = _2578._m0[(uint(_2569) * _2560) + 1u];
        _2574._m3 = _2578._m0[(uint(_2569) * _2560) + 2u];
        _2574._m4 = _2617._m0[(uint(_2570) * _2560) + 0u];
        _2574._m5 = _2617._m0[(uint(_2570) * _2560) + 1u];
        _2574._m6 = _2617._m0[(uint(_2570) * _2560) + 2u];
        float _2647 = _2578._m0[(uint(_2569) * _2560) + 3u].x;
        _2574._m7.x = _39(_2647);
        float _2657 = _2578._m0[(uint(_2569) * _2560) + 3u].y;
        _2574._m7.y = _39(_2657);
        float _2667 = _2578._m0[(uint(_2569) * _2560) + 3u].z;
        _2574._m7.z = _39(_2667);
        float _2677 = _2578._m0[(uint(_2569) * _2560) + 3u].w;
        _2574._m7.w = _39(_2677);
        _2574._m8 = _2686._m0[(uint(_2571) * _2560) + 0u];
        _2574._m9 = _2686._m0[(uint(_2571) * _2560) + 1u];
        _2574._m10 = _2686._m0[(uint(_2571) * _2560) + 2u];
        float _2716 = _2617._m0[(uint(_2570) * _2560) + 3u].x;
        _2574._m11 = _39(_2716);
        float _2726 = _2617._m0[(uint(_2570) * _2560) + 3u].y;
        _2574._m12 = _39(_2726);
        _2574._m13 = _2617._m0[(uint(_2570) * _2560) + 3u].z;
        float _2744 = _2617._m0[(uint(_2570) * _2560) + 3u].w;
        _2574._m14 = _39(_2744);
        float _2749 = 0.0039215688593685626983642578125;
        vec4 _2750 = vec4(_693._m14, 1.0);
        float _2757 = 1.0 / dot(_2750, _2574._m6);
        vec3 _2763 = vec3(dot(_2750, _2574._m4) * _2757, dot(_2750, _2574._m5) * _2757, dot(_2750, _2574._m3));
        uint _2781 = _2574._m1;
        uint _2784 = _1575;
        _2784 |= 64u;
        float _2788 = _2763.x;
        float _2791 = _2763.y;
        float _2794 = _2763.z;
        bool _2799 = _55(_2788, _2791, _2794) <= _2749;
        bool _2816;
        if (!_2799)
        {
            float _2803 = _2763.x;
            float _2806 = _2763.y;
            float _2809 = _2763.z;
            _2816 = _50(_2803, _2806, _2809) >= (1.0 - _2749);
        }
        else
        {
            _2816 = _2799;
        }
        bool _2824;
        if (!_2816)
        {
            _2824 = (_2781 & _2784) != 0u;
        }
        else
        {
            _2824 = _2816;
        }
        if (_2824)
        {
            continue;
        }
        if ((_2781 & 3u) == 2u)
        {
            vec2 _2843 = fract((_2763.xy * _725._m11.xy) + _725._m11.zw);
            _2763 = vec3(_2843.x, _2843.y, _2763.z);
        }
        vec3 _2846 = _2574._m0;
        float _2849 = 1.0;
        float _2850 = 1.0;
        vec3 _2851 = vec3(0.0, 0.0, 1.0);
        vec3 _2852 = vec3(0.0, 0.0, 1.0);
        uint _2853 = _2574._m1;
        vec3 _2856 = (_2763 * 2.0) - vec3(1.0);
        vec2 _2861 = _2763.xy;
        vec3 _2864 = _2574._m10.xyz;
        if ((_2853 & 3u) == 2u)
        {
            _2871 = _2864;
        }
        else
        {
            _2871 = normalize(_2846 - _693._m14);
        }
        _2851 = _2871;
        _2851 = _2851;
        float _2888 = dot(_693._m6, _2851);
        float _2883 = _10(_2888);
        bool _2892 = _2883 <= _2749;
        bool _2899;
        if (_2892)
        {
            _2899 = (_2853 & 48u) == 0u;
        }
        else
        {
            _2899 = _2892;
        }
        if (_2899)
        {
            continue;
        }
        uvec2 _2904 = _2574._m7.zw;
        vec4 _2903 = _101(_2904);
        float _2909 = TEXTURE_LOD(_2910, vec4((_2861 * _2903.xy) + _2903.zw, 0.0, 0.0).xy, vec4((_2861 * _2903.xy) + _2903.zw, 0.0, 0.0).w).x;
        float _2936 = _2909 * _2909;
        uint _2940 = _2853 & 3u;
        bool _2945 = _2940 == 1u;
        bool _2957;
        if (!_2945)
        {
            bool _2950 = _2940 == 0u;
            bool _2956;
            if (_2950)
            {
                _2956 = _2574._m8.z != 0.0;
            }
            else
            {
                _2956 = _2950;
            }
            _2957 = _2956;
        }
        else
        {
            _2957 = _2945;
        }
        bool _2943 = _2957;
        if (_2943)
        {
            float _2963 = _2574._m8.w;
            _2960 = _10(_2963);
        }
        else
        {
            _2960 = 0.5;
        }
        float _2958 = _2960;
        bool _2971 = _2940 == 0u;
        bool _2977;
        if (_2971)
        {
            _2977 = _2574._m8.z != 0.0;
        }
        else
        {
            _2977 = _2971;
        }
        if (_2977)
        {
            float _2986 = sqrt(dot(_2856, _2856));
            _2978 = min(0.9921875, _10(_2986));
        }
        else
        {
            _2978 = _2763.z;
        }
        float _2969 = _2978;
        uvec2 _2994 = _2574._m7.xy;
        vec4 _2993 = _101(_2994);
        vec2 _2999 = vec2(_2969, _2958);
        float _3003 = TEXTURE_LOD(_2910, vec4((_2999 * _2993.xy) + _2993.zw, 0.0, 0.0).xy, vec4((_2999 * _2993.xy) + _2993.zw, 0.0, 0.0).w).x;
        _3003 *= _3003;
        _2849 = _3003 * _2936;
        if ((_2853 & 48u) != 0u)
        {
            vec4 _3040 = _2574._m10;
            vec4 _3043 = _2574._m8;
            vec4 _3046 = _2574._m9;
            float _3049 = dot(_693._m14, _3040.xyz) + _3040.w;
            if (_3049 < 0.0)
            {
                continue;
            }
            float _3063 = length(_3040.xyz);
            float _3070 = _3049 * 50.0;
            float _3067 = _10(_3070);
            _2849 *= (_3067 * _3067);
            _3049 /= _3063;
            _3040 /= vec4(_3063);
            vec3 _3084 = reflect(-_693._m13, _693._m6);
            if (dot(_3084, _3040.xyz) > 0.0)
            {
                _3084 = reflect(_3084, _3040.xyz);
            }
            float _3102 = dot(_3084, _3040.xyz);
            float _3107 = _3049 / _3102;
            vec3 _3111 = _693._m14 - (_3084 * _3107);
            vec3 _3118 = _3111 - _2846;
            float _3122 = dot(_3118, _3043.xyz) / _3043.w;
            float _3130 = dot(_3118, _3046.xyz) / _3046.w;
            if ((_2853 & 48u) == 32u)
            {
                vec2 _3143 = vec2(_3122, _3130);
                float _3147 = 1.0 / max(1.0, length(vec2(_3122, _3130)));
                _3122 *= (_3147 * _3043.w);
                _3130 *= (_3147 * _3046.w);
            }
            else
            {
                float _3169 = abs(_3122);
                float _3171 = _3122;
                _3122 = (_10(_3169) * _81(_3171)) * _3043.w;
                float _3180 = abs(_3130);
                float _3182 = _3130;
                _3130 = (_10(_3180) * _81(_3182)) * _3046.w;
            }
            vec3 _3189 = (_3043.xyz * _3122) + (_3046.xyz * _3130);
            _2846 += _3189;
            _2851 = normalize(_2846 - _693._m14);
            _2851 = _2851;
        }
        else
        {
            uint _3209 = (_2574._m14 >> uint(16)) & 255u;
            if (_3209 == 0u)
            {
                vec4 _3218 = _2574._m9;
                if (dot(_3218.xyz, _693._m14) < (_3218.w - _2749))
                {
                    continue;
                }
            }
            else
            {
                if (_3209 == 1u)
                {
                    vec3 _3239 = _2574._m9.xyz;
                    float _3244 = _2574._m9.w;
                    uint _3248 = _39(_3244);
                    vec3 _3243 = (((_95(_3248) * 2.0) - vec3(1.0)) * _3239) + _2846;
                    vec3 _3257 = abs((_693._m14 - _3243) / _3239);
                    float _3265 = _3257.x;
                    float _3268 = _3257.y;
                    float _3271 = _3257.z;
                    if (_50(_3265, _3268, _3271) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2849 <= (_2749 / 256.0))
        {
            continue;
        }
        float _3287 = 1.0;
        if ((_2781 & 4u) != 0u)
        {
            float _3294 = float(_2574._m14 & 255u) / 255.0;
            float _3300 = 0.00999999977648258209228515625;
            vec3 _3302 = _693._m14 + (_693._m6 * _3300);
            uint _3310 = 0u;
            if ((_2781 & 3u) == 0u)
            {
                vec3 _3316 = _3302 - _2574._m2.xyz;
                float _3322 = _3316.x;
                float _3325 = _3316.y;
                float _3328 = _3316.z;
                _3310 = _61(_3322, _3325, _3328);
            }
            else
            {
                if ((_2781 & 3u) == 2u)
                {
                    float _3338 = 0.0;
                    for (; _3310 < 3u; _3310++)
                    {
                        int _3346 = 5;
                        _3349._m0 = _3353._m0[(uint(_3346) * ((_2781 >> uint(22)) + _3310)) + 0u];
                        _3349._m1 = _3353._m0[(uint(_3346) * ((_2781 >> uint(22)) + _3310)) + 1u];
                        _3349._m2 = _3353._m0[(uint(_3346) * ((_2781 >> uint(22)) + _3310)) + 2u];
                        _3349._m3 = _3353._m0[(uint(_3346) * ((_2781 >> uint(22)) + _3310)) + 3u];
                        _3349._m4 = _3353._m0[(uint(_3346) * ((_2781 >> uint(22)) + _3310)) + 4u];
                        vec2 _3410 = vec2(dot(_3302, _3349._m0.xyz) + _3349._m0.w, dot(_3302, _3349._m1.xyz) + _3349._m1.w);
                        _3410 = abs((_3410 * 2.0) - vec2(1.0));
                        bool _3435 = _3410.x < 1.0;
                        bool _3441;
                        if (_3435)
                        {
                            _3441 = _3410.y < 1.0;
                        }
                        else
                        {
                            _3441 = _3435;
                        }
                        if (_3441)
                        {
                            _3338 = (1.0 - max(_3410.x, _3410.y)) * _725._m12.w;
                            break;
                        }
                    }
                    _3310 = min(2u, _3310);
                    uint _3458 = uint(_693._m16.x) ^ (uint(_693._m16.y) << uint(1));
                    if (_725._m13.w > 0.0)
                    {
                        _3470 = uint(_725._m14.x);
                    }
                    else
                    {
                        _3470 = 0u;
                    }
                    _3458 ^= _3470;
                    _3310 += uint(int(((float(_3458 & 3u) * 0.25) + 0.125) > _3338));
                }
            }
            int _3492 = 5;
            _3493._m0 = _3353._m0[(uint(_3492) * ((_2781 >> uint(22)) + _3310)) + 0u];
            _3493._m1 = _3353._m0[(uint(_3492) * ((_2781 >> uint(22)) + _3310)) + 1u];
            _3493._m2 = _3353._m0[(uint(_3492) * ((_2781 >> uint(22)) + _3310)) + 2u];
            _3493._m3 = _3353._m0[(uint(_3492) * ((_2781 >> uint(22)) + _3310)) + 3u];
            _3493._m4 = _3353._m0[(uint(_3492) * ((_2781 >> uint(22)) + _3310)) + 4u];
            vec4 _3549 = vec4((_3302.x * _3493._m0.x) + ((_3302.y * _3493._m0.y) + ((_3302.z * _3493._m0.z) + _3493._m0.w)), (_3302.x * _3493._m1.x) + ((_3302.y * _3493._m1.y) + ((_3302.z * _3493._m1.z) + _3493._m1.w)), (_3302.x * _3493._m2.x) + ((_3302.y * _3493._m2.y) + ((_3302.z * _3493._m2.z) + _3493._m2.w)), (_3302.x * _3493._m3.x) + ((_3302.y * _3493._m3.y) + ((_3302.z * _3493._m3.z) + _3493._m3.w)));
            vec3 _3636 = _3549.xyz / vec3(_3549.w);
            _3549 = vec4(_3636.x, _3636.y, _3636.z, _3549.w);
            bool _3644 = min(_3549.x, _3549.y) > 0.0;
            bool _3653;
            if (_3644)
            {
                _3653 = max(_3549.x, _3549.y) < 1.0;
            }
            else
            {
                _3653 = _3644;
            }
            if (_3653)
            {
                vec2 _3665 = (_3549.xy * _3493._m4.xy) + _3493._m4.zw;
                _3549 = vec4(_3665.x, _3665.y, _3549.z, _3549.w);
                if (false)
                {
                    _3287 = textureLod(_3673, vec3(_3549.xyz.xy, _3549.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3680 = (_3549.xy * _725._m15.xy) + vec2(0.5);
                    vec2 _3689 = floor(_3680);
                    vec2 _3692 = _3680 - _3689;
                    _3689 -= vec2(0.5);
                    vec2 _3699 = vec2(4.0) - (_3692 * 3.0);
                    vec2 _3705 = vec2(7.0);
                    vec2 _3708 = vec2(1.0) + (_3692 * 3.0);
                    vec2 _3713 = (_3689 + (((vec2(3.0) - (_3692 * 2.0)) / _3699) - vec2(2.0))) * _725._m15.zw;
                    vec2 _3728 = (_3689 + ((vec2(3.0) + _3692) / _3705)) * _725._m15.zw;
                    vec2 _3740 = (_3689 + ((_3692 / _3708) + vec2(2.0))) * _725._m15.zw;
                    vec3 _3764 = vec3(_3713.x, _3713.y, _3549.z);
                    _3287 = (_3699.x * _3699.y) * textureLod(_3673, vec3(_3764.xy, _3764.z), 0.0);
                    vec3 _3780 = vec3(_3728.x, _3713.y, _3549.z);
                    _3287 += ((_3705.x * _3699.y) * textureLod(_3673, vec3(_3780.xy, _3780.z), 0.0));
                    vec3 _3798 = vec3(_3740.x, _3713.y, _3549.z);
                    _3287 += ((_3708.x * _3699.y) * textureLod(_3673, vec3(_3798.xy, _3798.z), 0.0));
                    vec3 _3816 = vec3(_3713.x, _3728.y, _3549.z);
                    _3287 += ((_3699.x * _3705.y) * textureLod(_3673, vec3(_3816.xy, _3816.z), 0.0));
                    vec3 _3834 = vec3(_3728.x, _3728.y, _3549.z);
                    _3287 += ((_3705.x * _3705.y) * textureLod(_3673, vec3(_3834.xy, _3834.z), 0.0));
                    vec3 _3852 = vec3(_3740.x, _3728.y, _3549.z);
                    _3287 += ((_3708.x * _3705.y) * textureLod(_3673, vec3(_3852.xy, _3852.z), 0.0));
                    vec3 _3870 = vec3(_3713.x, _3740.y, _3549.z);
                    _3287 += ((_3699.x * _3708.y) * textureLod(_3673, vec3(_3870.xy, _3870.z), 0.0));
                    vec3 _3888 = vec3(_3728.x, _3740.y, _3549.z);
                    _3287 += ((_3705.x * _3708.y) * textureLod(_3673, vec3(_3888.xy, _3888.z), 0.0));
                    vec3 _3906 = vec3(_3740.x, _3740.y, _3549.z);
                    _3287 += ((_3708.x * _3708.y) * textureLod(_3673, vec3(_3906.xy, _3906.z), 0.0));
                    _3287 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3287 = float((_2781 & 3u) == 2u);
            }
            float _3920 = float((_2781 >> uint(16)) & 63u) / 63.0;
            float _3934 = ((_3287 * _3920) + 1.0) - _3920;
            _3287 = _10(_3934);
        }
        uint _3937 = _2574._m12;
        vec3 _3936 = (_119(_3937) * _3287) * _2849;
        _2850 *= _2574._m13;
        vec3 _3949 = _3936;
        vec3 _3951 = _2851;
        float _3958 = dot(_693._m6, _3951);
        float _3953 = _10(_3958);
        vec3 _3964 = _693._m6;
        vec3 _3967 = _693._m13;
        vec3 _3970 = _2851;
        vec3 _3972 = _693._m2;
        float _3975 = abs(_693._m3);
        vec3 _3960 = _132(_3964, _3967, _3970, _3972, _3975);
        _693._m20 += (((_3960 * _2850) * _3949) * _3953);
        vec3 _3989 = mix(_3949, vec3(0.0), bvec3((_2781 & 256u) > 0u));
        _693._m19 += (_3989 * _3953);
    }
    _693._m19 = _693._m19;
    _693._m20 += _693._m10;
    float _4013 = 0.064999997615814208984375;
    float _4015 = 1.0 + _4013;
    bool _4018 = false;
    uint _4023;
    if (_725._m16.w > 0.00999999977648258209228515625)
    {
        _4023 = uint(_725._m16.x);
    }
    else
    {
        _4023 = 0u;
    }
    uint _4019 = _4023;
    _4041 _4043;
    for (uint _4031 = 0u; _4031 < _4019; _4031++)
    {
        int _4040 = 4;
        _4043._m0 = _4047._m0[(uint(_4040) * _4031) + 0u];
        _4043._m1 = _4047._m0[(uint(_4040) * _4031) + 1u];
        _4043._m2 = _4047._m0[(uint(_4040) * _4031) + 2u];
        float _4077 = _4047._m0[(uint(_4040) * _4031) + 3u].x;
        _4043._m3 = _39(_4077);
        float _4087 = _4047._m0[(uint(_4040) * _4031) + 3u].y;
        _4043._m4 = _39(_4087);
        float _4097 = _4047._m0[(uint(_4040) * _4031) + 3u].z;
        _4043._m5 = _39(_4097);
        vec4 _4102 = vec4(_693._m14, 1.0);
        vec3 _4109 = vec3(dot(_4102, _4043._m1), dot(_4102, _4043._m2), dot(_4102, _4043._m0));
        float _4123 = _4109.x;
        float _4126 = _4109.y;
        float _4129 = _4109.z;
        bool _4133 = _55(_4123, _4126, _4129) >= 0.0;
        bool _4142;
        if (_4133)
        {
            _4142 = max(_4109.x, _4109.y) < 1.0;
        }
        else
        {
            _4142 = _4133;
        }
        bool _4149;
        if (_4142)
        {
            _4149 = _4109.z < _4015;
        }
        else
        {
            _4149 = _4142;
        }
        if (_4149)
        {
            float _4152 = _4109.z;
            vec4 _4155 = vec4(_693._m14, 1.0);
            vec2 _4162 = vec2(0.0);
            _4162 = (((_4155.xy - _725._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4175 = 0.000244140625;
            float _4181 = abs(_693._m6.z) * 2.0;
            _4175 *= _10(_4181);
            vec3 _4185 = vec3(TEXTURE_LOD(_4186, vec4(_4162 + vec2(_4175), 0.0, 0.0).xy, vec4(_4162 + vec2(_4175), 0.0, 0.0).w).x, TEXTURE_LOD(_4186, vec4(_4162, 0.0, 0.0).xy, vec4(_4162, 0.0, 0.0).w).x, TEXTURE_LOD(_4186, vec4(_4162 - vec2(_4175), 0.0, 0.0).xy, vec4(_4162 - vec2(_4175), 0.0, 0.0).w).x);
            float _4249 = 2.0 - (2.0 * (length(_4155.xy - _725._m17.zw) / 16.0));
            _4185 *= _10(_4249);
            float _4256 = 1.0 - _4152;
            float _4253 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4256));
            float _4267 = (_693._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4259 = (_4185 * _4253) * _10(_4267);
            float _4276 = _4015 - _4152;
            float _4270 = (1.0 - _4253) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4276));
            float _4291 = ((-_693._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4280 = (_4185 * _4270) * _10(_4291);
            _4185 = _4259 + _4280;
            float _4302 = 1.02499997615814208984375 - _4152;
            float _4297 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4302));
            float _4305 = _725._m16.w;
            _693._m19 = mix(_693._m19, (_693._m19 * _4185) + (_693._m19 * mix(1.0, 0.5, _4297)), vec3(_4305));
            break;
        }
    }
    _693._m19 *= _693._m0;
    _693._m21 = _693._m19 + _693._m20;
    vec3 _4345 = _693._m19 + _693._m20;
    _4340 = vec4(_4345.x, _4345.y, _4345.z, _4340.w);
    vec3 _4349 = _693._m6;
    bool _4352 = false;
    vec2 _4353 = _162(_4349, _4352);
    _4348 = vec4(_4353.x, _4353.y, _4348.z, _4348.w);
    float _4357 = _693._m2.x;
    float _4361 = _693._m2.y;
    float _4365 = _693._m2.z;
    float _4369 = _693._m3;
    _4356 = vec4(_84(_4357), _84(_4361), _84(_4365), _165(_4369));
    vec3 _4379 = _4340.xyz + _1019._m2.xyz;
    _4340 = vec4(_4379.x, _4379.y, _4379.z, _4340.w);
}


