// More Decals
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _682
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1156
{
    int _m0;
    int _m1;
};

struct _1159
{
    int _m0;
    int _m1;
};

struct _1270
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2124
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _2899
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _703_705
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _705;

layout(set = 2, binding = 0, std140) uniform _806_808
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _808;

layout(set = 1, binding = 0, std140) uniform _992_994
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
} _994;

layout(set = 0, binding = 12, std430) restrict readonly buffer _1161_1163
{
    _1159 _m0[];
} _1163;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1245_1247
{
    uint _m0[];
} _1247;

layout(set = 0, binding = 14, std140) uniform _1275_1277
{
    vec4 _m0[4096];
} _1277;

layout(set = 0, binding = 15, std140) uniform _1295_1297
{
    vec4 _m0[4096];
} _1297;

layout(set = 0, binding = 16, std140) uniform _1347_1349
{
    vec4 _m0[4096];
} _1349;

layout(set = 0, binding = 18, std140) uniform _2128_2130
{
    vec4 _m0[4096];
} _2130;

layout(set = 0, binding = 19, std140) uniform _2167_2169
{
    vec4 _m0[4096];
} _2169;

layout(set = 0, binding = 20, std140) uniform _2236_2238
{
    vec4 _m0[3072];
} _2238;

layout(set = 0, binding = 22, std140) uniform _2903_2905
{
    vec4 _m0[4095];
} _2905;

layout(set = 0, binding = 1, std430) restrict readonly buffer _3971_3973
{
    vec4 _m0[];
} _3973;

layout(push_constant, std430) uniform _3967_3969
{
    int _m0;
    int _m1;
} _3969;

layout(set = 3, binding = 3) uniform TEXTURE_2D _833[8];
layout(set = 0, binding = 5) uniform sampler _840;
layout(set = 3, binding = 2) uniform TEXTURE_2D _884[8];
layout(set = 0, binding = 6) uniform sampler _888;
layout(set = 3, binding = 0) uniform TEXTURE_2D _899[8];
layout(set = 0, binding = 7) uniform sampler _903;
layout(set = 3, binding = 1) uniform TEXTURE_2D _914[8];
layout(set = 0, binding = 8) uniform sampler _918;
layout(set = 3, binding = 7) uniform TEXTURE_2D _928[8];
layout(set = 0, binding = 9) uniform sampler _932;
layout(set = 3, binding = 4) uniform TEXTURE_2D _941[8];
layout(set = 0, binding = 10) uniform sampler _945;
layout(set = 3, binding = 6) uniform TEXTURE_2D _954[8];
layout(set = 0, binding = 11) uniform sampler _958;
layout(set = 0, binding = 17) uniform SAMPLER_2D _1569;
layout(set = 0, binding = 21) uniform SAMPLER_2D _2462;
layout(set = 0, binding = 23) uniform sampler2DShadow _3225;
layout(set = 0, binding = 24) uniform SAMPLER_2D _3608;
layout(set = 2, binding = 1) uniform SAMPLER_2D _3803;
layout(set = 3, binding = 5) uniform TEXTURE_2D _3966[8];
layout(set = 0, binding = 3) uniform sampler3D _3977;
layout(set = 0, binding = 4) uniform sampler3D _3978;

layout(location = 2) in vec4 _696;
layout(location = 6) in vec4 _710;
layout(location = 3) in vec4 _722;
layout(location = 4) in vec4 _725;
layout(location = 5) in vec4 _728;
layout(location = 10) in vec4 _746;
layout(location = 11) in vec4 _750;
layout(location = 12) in vec4 _754;
layout(location = 14) flat in uvec3 _767;
layout(location = 15) in vec4 _770;
layout(location = 7) in vec4 _3805;
layout(location = 0) out vec4 _3924;
layout(location = 1) out vec4 _3932;
layout(location = 2) out vec4 _3940;

uvec4 _41(vec4 _40)
{
    return floatBitsToUint(_40);
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

float _136(float _132, vec4 _133, float _134, bool _135)
{
    float _537 = _133.w / (_132 + _133.z);
    return _537 * _134;
}

vec3 _141(vec3 _139, bool _140)
{
    vec3 _550 = (_139 * 2.0) - vec3(1.0);
    float _567 = (1.0 - (_550.x * _550.x)) - (_550.y * _550.y);
    _550.z = sqrt(_14(_567));
    if (_140 == false)
    {
        _550.z = -_550.z;
    }
    return _550;
}

vec3 _148(vec3 _146, mat3 _147)
{
    return normalize(vec3(dot(_146, _147[0]), dot(_146, _147[1]), dot(_146, _147[2])));
}

uint _36(float _35)
{
    return floatBitsToUint(_35);
}

float _52(float _49, float _50, float _51)
{
    return min(_49, min(_50, _51));
}

float _47(float _44, float _45, float _46)
{
    return max(_44, max(_45, _46));
}

vec4 _86(uint _85)
{
    return unpackUnorm4x8(_85).wzyx;
}

vec4 _99(uvec2 _98)
{
    return vec4(float((_98.x >> uint(16)) & 65535u), float(_98.x & 65535u), float((_98.y >> uint(16)) & 65535u), float(_98.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _111(SAMPLER_2D _107, vec2 _108, vec2 _109, vec2 _110)
{
    return TEXTURE_GRAD(_107, _108, _109, _110);
}

float _61(float _60)
{
    return _60 * ((_60 * ((_60 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _89(uint _88)
{
    return vec4(float((_88 >> uint(24)) & 255u), float((_88 >> uint(16)) & 255u), float((_88 >> uint(8)) & 255u), float(_88 & 255u));
}

vec3 _64(vec3 _63)
{
    float _271 = _63.x;
    vec3 _270;
    _270.x = _61(_271);
    float _277 = _63.y;
    _270.y = _61(_277);
    float _283 = _63.z;
    _270.z = _61(_283);
    return _270;
}

vec4 _67(vec4 _66)
{
    vec3 _293 = _66.xyz;
    vec4 _292 = vec4(_64(_293), 1.0);
    float _301 = _66.w;
    _292.w = _61(_301);
    return _292;
}

float _78(float _77)
{
    return (step(0.0, _77) * 2.0) - 1.0;
}

vec4 _26(vec4 _25)
{
    return clamp(_25, vec4(0.0), vec4(1.0));
}

vec3 _93(uint _92)
{
    return vec3(float((_92 >> uint(21)) & 2047u), float((_92 >> uint(10)) & 2047u), float(_92 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _58(float _55, float _56, float _57)
{
    bool _216 = abs(_57) >= abs(_55);
    bool _224;
    if (_216)
    {
        _224 = abs(_57) >= abs(_56);
    }
    else
    {
        _224 = _216;
    }
    if (_224)
    {
        return uint((_57 < 0.0) ? 5 : 4);
    }
    if (abs(_56) >= abs(_55))
    {
        return uint((_56 < 0.0) ? 3 : 2);
    }
    return uint(int(_55 < 0.0));
}

float _70(float _69)
{
    return exp2(_69);
}

vec3 _114(uint _113)
{
    uint _411 = _113;
    vec4 _410 = _86(_411);
    float _422 = (_410.w * 255.0) - 128.0;
    return _410.xyz * _70(_422);
}

float _75(float _73, float _74)
{
    return pow(_73, _74);
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

vec3 _119(vec3 _117, float _118)
{
    float _434 = 50.0 * dot(_117, vec3(0.33329999446868896484375));
    float _427 = _14(_434);
    float _443 = 1.0 - _118;
    float _446 = _14(_443);
    float _447 = 5.0;
    vec3 _451 = _117 + ((vec3(_427) - _117) * _75(_446, _447));
    return _20(_451);
}

vec3 _127(vec3 _122, vec3 _123, vec3 _124, vec3 _125, float _126)
{
    vec3 _455 = normalize(_123 + _124);
    float _460 = 1.0 - (_126 * 0.800000011920928955078125);
    _460 *= _460;
    _460 *= _460;
    float _471 = _460 * _460;
    float _479 = dot(_122, _455);
    float _475 = _14(_479);
    float _481 = ((_475 * _475) * (_471 - 1.0)) + 1.0;
    _481 = _471 / ((_481 * _481) + 9.9999999392252902907785028219223e-09);
    float _500 = dot(_122, _123);
    float _496 = (_14(_500) * (1.0 - _460)) + _460;
    float _511 = dot(_122, _124);
    float _507 = (_14(_511) * (1.0 - _460)) + _460;
    _481 /= (((4.0 * _496) * _507) + 9.9999999392252902907785028219223e-09);
    vec3 _529 = _125;
    float _531 = dot(_124, _455);
    return _119(_529, _531) * _481;
}

float _31(vec4 _29, vec4 _30)
{
    return dot(_29, _30);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

vec2 _152(vec2 _151)
{
    return (vec2(1.0) - abs(_151.yx)) * vec2((_151.x >= 0.0) ? 1.0 : (-1.0), (_151.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _157(inout vec3 _155, bool _156)
{
    _155 /= vec3((abs(_155.x) + abs(_155.y)) + abs(_155.z));
    vec2 _634;
    if (_155.z >= 0.0)
    {
        _634 = _155.xy;
    }
    else
    {
        vec2 _640 = _155.xy;
        _634 = _152(_640);
    }
    _155 = vec3(_634.x, _634.y, _155.z);
    if (_156)
    {
        vec2 _655 = (_155.xy * 0.5) + vec2(0.5);
        _155 = vec3(_655.x, _655.y, _155.z);
    }
    return _155.xy;
}

float _81(float _80)
{
    return sqrt(_80);
}

float _160(float _159)
{
    float _665 = abs(_159);
    float _662 = _81(_665);
    float _669;
    if (_159 > 0.0)
    {
        _669 = _662;
    }
    else
    {
        _669 = -_662;
    }
    return (_669 * 0.5) + 0.5;
}

void main()
{
    _682 _684 = _682(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _684._m15 = _696;
    _684._m16 = gl_FragCoord;
    _684._m14 = _705._m0.xyz + _710.xyz;
    _684._m13 = normalize(-_710.xyz);
    _684._m17 = mat3(vec3(_722.xyz), vec3(_725.xyz), vec3(_728.xyz));
    _684._m34 = _746;
    _684._m35 = _750;
    _684._m36 = _754;
    uint _757 = 0u;
    vec4 _758 = vec4(0.0);
    vec4 _759 = vec4(0.0);
    vec4 _760 = vec4(0.0);
    vec4 _761 = vec4(0.0);
    vec4 _762 = vec4(0.0);
    uvec3 _765 = _767;
    vec3 _769 = _770.xyz;
    bool _776 = _765.y == 65535u;
    bool _782;
    if (_776)
    {
        _782 = _765.z == 65535u;
    }
    else
    {
        _782 = _776;
    }
    bool _773 = _782;
    bool _783 = !_773;
    bool _786 = _765.z != 65535u;
    uint _790 = _765.x & 7u;
    uint _801;
    if (_705._m2.x == 0.0)
    {
        _801 = _790;
    }
    else
    {
        vec4 _809 = _808._m2;
        uvec4 _805 = _41(_809);
        uint _813 = _805[_790 / 2u];
        uint _818 = 16u * (_790 & 1u);
        _801 = (_813 >> _818) & 65535u;
    }
    uint _827 = _801;
    float _829 = SAMPLE_TEXTURE(SAMPLER_2D(_833[_827], _840), _684._m15.zw).x;
    float _859 = pow(_829, 0.125) - 0.800000011920928955078125;
    vec2 _848 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_14(_859) / 0.20000000298023223876953125));
    vec2 _867 = dFdx(_684._m15.zw) * _848.x;
    vec2 _875 = dFdy(_684._m15.zw) * _848.y;
    vec2 _883 = TEXTURE_GRAD(SAMPLER_2D(_884[_827], _888), _684._m15.zw, _867, _875).yx;
    vec3 _898 = SAMPLE_TEXTURE(SAMPLER_2D(_899[_827], _903), _684._m15.zw).xyz;
    vec3 _911 = vec3(0.039999999105930328369140625);
    _911 = SAMPLE_TEXTURE(SAMPLER_2D(_914[_827], _918), _684._m15.zw).xyz;
    float _926 = 1.0;
    float _927 = SAMPLE_TEXTURE(SAMPLER_2D(_928[_827], _932), _684._m15.zw).x;
    float _940 = SAMPLE_TEXTURE(SAMPLER_2D(_941[_827], _945), _684._m15.zw).x;
    vec3 _953 = SAMPLE_TEXTURE(SAMPLER_2D(_954[_827], _958), _684._m15.zw).xyz;
    _760 = vec4(_898.x, _898.y, _898.z, _760.w);
    _760.w = _883.y;
    _761 = vec4(_911.x, _911.y, _911.z, _761.w);
    _761.w = _940;
    _762 = vec4(_762.x, _883.x, _762.z, _883.y);
    _758.x = _927;
    _758.y = _926;
    _758.z = _940;
    _758.w = _829;
    _759 = vec4(_953.x, _953.y, _953.z, _759.w);
    vec3 _991 = (_994._m7.xyz * _808._m3.xyz) * mix(_760.xyz, vec3(1.0), vec3(_994._m7.w));
    _684._m10 = vec3(((_808._m4.x * _758.x) * _758.x) * _994._m8.x) * _991;
    _684._m10 *= vec3(_705._m3.x);
    _684._m0 = _760.xyz;
    _684._m2 = _761.xyz;
    _684._m1 = _759.xyz;
    _684._m9 = _758.xyz;
    _684._m3 = _758.w;
    _684._m6 = _762.wyz;
    uint _1053 = uint((_994._m9.x > 0.0) ? 8 : 0);
    float _1059 = 16.0;
    float _1061 = 8.0;
    float _1063 = 24.0;
    vec2 _1072 = _684._m16.xy * _705._m4.xy;
    vec3 _1065;
    _1065 = vec3(_1072.x, _1072.y, _1065.z);
    _1065.y = 1.0 - _1065.y;
    
      // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
    _1065.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1085 = floor(_1065.xy * vec2(_1059, _1061));
    _1065 = vec3(_1085.x, _1085.y, _1065.z);
    float _1089 = _684._m16.z;
    vec4 _1092 = _705._m5;
    float _1095 = 1.0;
    bool _1096 = false;
    float _1088 = _136(_1089, _1092, _1095, _1096);
    float _1098 = log2(max(1.0, _1088 / _705._m6.z)) * _705._m6.w;
    _1065.z = min(_1063 - 1.0, floor(_1098));
    uint _1114 = uint((_1065.x + (_1065.y * _1059)) + ((_1065.z * _1059) * _1061));
    bool _1130 = true;
    vec3 _1132 = _684._m6;
    bool _1135 = _1130;
    _684._m7 = _141(_1132, _1135);
    vec3 _1139 = _684._m7;
    mat3 _1142 = _684._m17;
    _684._m6 = _148(_1139, _1142);
    uint _1147 = 0u;
    uint _1148 = 0u;
    uint _1149 = 0u;
    uint _1150 = 0u;
    uint _1151 = 0u;
    uint _1152 = 0u;
    int _1154 = 256;
    _1156 _1158;
    _1158._m0 = _1163._m0[_1114]._m0;
    _1158._m1 = _1163._m0[_1114]._m1;
    int _1172 = _1158._m0 & (~(_1158._m0 >> 31));
    int _1181 = _1158._m1 & (~(_1158._m1 >> 31));
    _1147 = uint((_1172 >> 16) * _1154);
    _1148 = _1147 + uint(_1181 & 255);
    _1149 = _1147;
    _1150 = _1149 + uint((_1181 >> 8) & 255);
    _1151 = _1147;
    _1152 = _1151 + uint((_1181 >> 16) & 255);
    vec3 _1214 = dFdx(_684._m14);
    vec3 _1218 = dFdy(_684._m14);
    bool _1223 = _1053 == 0u;
    bool _1229;
    if (_1223)
    {
        _1229 = _994._m9.y == 0.0;
    }
    else
    {
        _1229 = _1223;
    }
    _1149 = _1229 ? _1150 : _1149;
    uint _1233 = _1149;
    _1270 _1272;
    vec3 _1626;
    float _1759;
    while (_1233 < _1150)
    {
        uint _1243 = _1247._m0[_1233];
        uint _1252 = (_1243 >> uint(12)) & 4095u;
        uint _1258 = _1252;
        if (_1258 >= _1252)
        {
            _1233++;
        }
        int _1267 = 2;
        int _1268 = 2;
        int _1269 = 2;
        _1272._m0 = _1277._m0[(uint(_1267) * _1258) + 0u];
        _1272._m1 = _1277._m0[(uint(_1267) * _1258) + 1u];
        _1272._m2 = _1297._m0[(uint(_1268) * _1258) + 0u];
        float _1311 = _1297._m0[(uint(_1268) * _1258) + 1u].x;
        _1272._m3.x = _36(_1311);
        float _1321 = _1297._m0[(uint(_1268) * _1258) + 1u].y;
        _1272._m3.y = _36(_1321);
        float _1331 = _1297._m0[(uint(_1268) * _1258) + 1u].z;
        _1272._m4.x = _36(_1331);
        float _1341 = _1297._m0[(uint(_1268) * _1258) + 1u].w;
        _1272._m4.y = _36(_1341);
        float _1355 = _1349._m0[(uint(_1269) * _1258) + 0u].x;
        _1272._m5.x = _36(_1355);
        float _1365 = _1349._m0[(uint(_1269) * _1258) + 0u].y;
        _1272._m5.y = _36(_1365);
        float _1375 = _1349._m0[(uint(_1269) * _1258) + 0u].z;
        _1272._m6 = _36(_1375);
        float _1385 = _1349._m0[(uint(_1269) * _1258) + 0u].w;
        _1272._m7 = _36(_1385);
        float _1395 = _1349._m0[(uint(_1269) * _1258) + 1u].x;
        _1272._m8 = _36(_1395);
        float _1405 = _1349._m0[(uint(_1269) * _1258) + 1u].y;
        _1272._m9 = _36(_1405);
        float _1415 = _1349._m0[(uint(_1269) * _1258) + 1u].z;
        _1272._m10 = _36(_1415);
        float _1426 = _1349._m0[(uint(_1269) * _1258) + 1u].w;
        _1272._m11 = _36(_1426);
        vec4 _1431 = _1272._m0;
        vec4 _1434 = _1272._m2;
        vec4 _1437 = _1272._m1;
        vec4 _1440 = vec4(_684._m14, 1.0);
        vec3 _1447 = vec3(dot(_1440, _1431), dot(_1440, _1437), dot(_1440, _1434));
        float _1458 = 0.0039215688593685626983642578125;
        float _1460 = _1447.x;
        float _1463 = _1447.y;
        float _1466 = _1447.z;
        bool _1471 = _52(_1460, _1463, _1466) <= _1458;
        bool _1488;
        if (!_1471)
        {
            float _1475 = _1447.x;
            float _1478 = _1447.y;
            float _1481 = _1447.z;
            _1488 = _47(_1475, _1478, _1481) >= (1.0 - _1458);
        }
        else
        {
            _1488 = _1471;
        }
        if (_1488)
        {
            continue;
        }
        uint _1492 = _1272._m11;
        bool _1496 = _1053 != 0u;
        bool _1503;
        if (_1496)
        {
            _1503 = (_1492 & 512u) != 0u;
        }
        else
        {
            _1503 = _1496;
        }
        bool _1516;
        if (!_1503)
        {
            bool _1508 = _1053 == 0u;
            bool _1515;
            if (_1508)
            {
                _1515 = (_1492 & 1024u) != 0u;
            }
            else
            {
                _1515 = _1508;
            }
            _1516 = _1515;
        }
        else
        {
            _1516 = _1503;
        }
        if (_1516)
        {
            continue;
        }
        vec2 _1520 = vec2(dot(_1214, _1431.xyz), dot(_1214, _1437.xyz));
        vec2 _1530 = vec2(dot(_1218, _1431.xyz), dot(_1218, _1437.xyz));
        float _1540 = 1.0;
        float _1541 = 1.0;
        vec3 _1542 = vec3(0.5, 0.5, 1.0);
        vec3 _1544 = vec3(0.0, 0.0, 1.0);
        uint _1545 = _1272._m7;
        uint _1549 = _1272._m9;
        vec4 _1548 = _86(_1549);
        uvec2 _1554 = _1272._m5;
        vec4 _1553 = _99(_1554);
        vec2 _1558 = _1520 * _1553.xy;
        vec2 _1563 = _1530 * _1553.xy;
        vec2 _1578 = (_1447.xy * _1553.xy) + _1553.zw;
        vec2 _1579 = _1558;
        vec2 _1581 = _1563;
        vec4 _1568 = _111(_1569, _1578, _1579, _1581);
        vec2 _1584 = (_1568.xy * 2.0) - vec2(1.0);
        float _1594 = 1.0 - dot(_1584, _1584);
        _1542 = vec3(_1584, sqrt(_14(_1594)));
        _1544 = _1542;
        _1540 = _1568.z;
        float _1603 = _1568.w;
        _1541 = _61(_1603);
        bool _1610 = _1541 <= (4.0 * _1458);
        bool _1617;
        if (_1610)
        {
            _1617 = _1548.w <= _1458;
        }
        else
        {
            _1617 = _1610;
        }
        if (_1617)
        {
            continue;
        }
        _1542 = _1544;
        if ((_1492 & 128u) != 0u)
        {
            _1626 = vec3(-_1542.x, -_1542.y, _1542.z);
        }
        else
        {
            _1626 = _1542;
        }
        _1542 = _1626;
        uint _1641 = _1272._m8;
        uint _1645 = _1641;
        float _1644 = 1.0 + (_89(_1645).w * 0.062745101749897003173828125);
        uint _1653 = _1545;
        float _1652 = _86(_1653).z;
        uint _1658 = _1641;
        vec3 _1657 = _86(_1658).xyz;
        float _1671 = _1644 - (_1644 * abs((_1447.z * 2.0) - 1.0));
        _1541 *= _14(_1671);
        float _1675 = _1541;
        if ((_1545 & 1u) != 0u)
        {
            vec3 _1682 = _1657;
            _1657 = vec3(0.0);
            uvec2 _1685 = _1272._m3;
            vec4 _1684 = _99(_1685);
            vec2 _1689 = _1520 * _1684.xy;
            vec2 _1694 = _1530 * _1684.xy;
            vec2 _1708 = (_1447.xy * _1684.xy) + _1684.zw;
            vec2 _1709 = _1689;
            vec2 _1711 = _1694;
            vec4 _1699 = _111(_1569, _1708, _1709, _1711);
            vec4 _1714 = _1699;
            _1699 = _67(_1714);
            _1657 = _1699.xyz;
            float _1726 = (_1699.w - _1458) / (1.0 - _1458);
            _1675 = _14(_1726);
            _1657 *= _1682;
        }
        vec3 _1731 = normalize(vec3(_684._m17[0].z, _684._m17[1].z, _684._m17[2].z));
        float _1740 = dot(_1731, normalize(_1434.xyz));
        float _1746 = _1740;
        vec2 _1751 = _1542.xy * _78(_1746);
        _1542 = vec3(_1751.x, _1751.y, _1542.z);
        if ((_1492 & 16384u) != 0u)
        {
            float _1764 = abs(_1740);
            _1759 = _14(_1764);
        }
        else
        {
            float _1767 = _1740;
            _1759 = _14(_1767);
        }
        float _1754 = _1759;
        float _1771 = ((_1754 * _1675) * _1548.w) * _1652;
        _684._m10 += (_1548.xyz * (_1771 * 64.0));
        uint _1790 = _1272._m10;
        uint _1794 = _1790;
        vec4 _1793 = _86(_1794);
        if ((_1545 & 2u) != 0u)
        {
            uvec2 _1803 = _1272._m4;
            vec4 _1802 = _99(_1803);
            vec2 _1807 = _1520 * _1802.xy;
            vec2 _1812 = _1530 * _1802.xy;
            vec2 _1825 = (_1447.xy * _1802.xy) + _1802.zw;
            vec2 _1826 = _1807;
            vec2 _1828 = _1812;
            _1793 = _111(_1569, _1825, _1826, _1828);
            _1793 *= _1793;
        }
        if ((_1545 & 32u) != 0u)
        {
            uint _1841 = _1545;
            float _1840 = _86(_1841).x;
            uint _1846 = _1545;
            float _1845 = _89(_1846).y;
            float _1852 = _1840;
            float _1850 = mix(_1845, 0.0, _14(_1852));
            float _1861 = _1540 - (_1850 / 255.0);
            float _1856 = float(_14(_1861) > 0.0);
            _1541 *= _1856;
        }
        float _1868 = _1541 * _1754;
        uint _1872 = _1272._m6;
        uint _1876 = _1872;
        vec4 _1881 = _86(_1876) * _1868;
        vec4 _1875 = _26(_1881);
        _684._m11 = max(_684._m11, _1875.x);
        _684._m0 = mix(_684._m0, _1657, _1875.xxx);
        _684._m2 = mix(_684._m2, _1793.xyz, _1875.yyy);
        vec3 _1904 = _1731;
        vec3 _1914 = _1431.xyz + (_1904 * dot(_1431.xyz, _1904));
        _1431 = vec4(_1914.x, _1914.y, _1914.z, _1431.w);
        vec3 _1925 = _1437.xyz + (_1904 * dot(_1437.xyz, _1904));
        _1437 = vec4(_1925.x, _1925.y, _1925.z, _1437.w);
        _1542 = ((normalize(_1431.xyz) * _1542.x) + (normalize(_1437.xyz) * _1542.y)) + (_1904 * _1542.z);
        if ((_1492 & 256u) != 0u)
        {
            vec3 _1952 = mix(_1731, _1542, _1875.www);
            float _1958 = dot(_1952, _1731);
            _1542 = (_684._m6 * _1958) + ((_1952 - (_1731 * _1958)) * dot(_684._m6, _1731));
        }
        else
        {
            if ((_1492 & 64u) != 0u)
            {
                _1542 = mix(mix(_684._m6, _1731, vec3(_1868)), _1542, _1875.www);
            }
            else
            {
                _1542 = mix(_684._m6, _1542, _1875.www);
            }
        }
        _684._m6 = normalize(_1542);
        _684._m3 = mix(_684._m3, _1793.w, _1875.z);
    }
    vec3 _2012 = vec3(0.0);
    vec3 _2013 = vec3(_684._m34.x, _684._m34.y, _684._m34.z);
    vec3 _2021 = vec3(_684._m34.w, _684._m35.x, _684._m35.y);
    vec3 _2029 = vec3(_684._m35.z, _684._m35.w, _684._m36.x);
    vec3 _2037 = vec3(_684._m36.y, _684._m36.z, _684._m36.w);
    vec3 _2045 = ((_2013 - (_2021 * _684._m6.y)) + (_2029 * _684._m6.z)) - (_2037 * _684._m6.x);
    float _2068 = _994._m10.x * _705._m7.x;
    _2012 += max(_2045 * _14(_2068), vec3(0.0));
    float _2078;
    if (dot(_684._m10, vec3(1.0)) > 0.0)
    {
        _2078 = -_684._m3;
    }
    else
    {
        _2078 = _684._m3;
    }
    _684._m3 = _2078;
    _684._m18 = _2012;
    _684._m19 = _2012;
    uint _2095 = _1147;
    _2124 _2126;
    vec3 _2423;
    float _2512;
    float _2530;
    _2899 _2901;
    uint _3022;
    _2899 _3045;
    while (_2095 < _1148)
    {
        uint _2105 = _1247._m0[_2095];
        uint _2109 = _2105 & 4095u;
        uint _2112 = _2109;
        if (_2112 >= _2109)
        {
            _2095++;
        }
        int _2121 = 4;
        int _2122 = 4;
        int _2123 = 3;
        _2126._m0 = _2130._m0[(uint(_2121) * _2112) + 0u].xyz;
        float _2145 = _2130._m0[(uint(_2121) * _2112) + 0u].w;
        _2126._m1 = _36(_2145);
        _2126._m2 = _2130._m0[(uint(_2121) * _2112) + 1u];
        _2126._m3 = _2130._m0[(uint(_2121) * _2112) + 2u];
        _2126._m4 = _2169._m0[(uint(_2122) * _2112) + 0u];
        _2126._m5 = _2169._m0[(uint(_2122) * _2112) + 1u];
        _2126._m6 = _2169._m0[(uint(_2122) * _2112) + 2u];
        float _2199 = _2130._m0[(uint(_2121) * _2112) + 3u].x;
        _2126._m7.x = _36(_2199);
        float _2209 = _2130._m0[(uint(_2121) * _2112) + 3u].y;
        _2126._m7.y = _36(_2209);
        float _2219 = _2130._m0[(uint(_2121) * _2112) + 3u].z;
        _2126._m7.z = _36(_2219);
        float _2229 = _2130._m0[(uint(_2121) * _2112) + 3u].w;
        _2126._m7.w = _36(_2229);
        _2126._m8 = _2238._m0[(uint(_2123) * _2112) + 0u];
        _2126._m9 = _2238._m0[(uint(_2123) * _2112) + 1u];
        _2126._m10 = _2238._m0[(uint(_2123) * _2112) + 2u];
        float _2268 = _2169._m0[(uint(_2122) * _2112) + 3u].x;
        _2126._m11 = _36(_2268);
        float _2278 = _2169._m0[(uint(_2122) * _2112) + 3u].y;
        _2126._m12 = _36(_2278);
        _2126._m13 = _2169._m0[(uint(_2122) * _2112) + 3u].z;
        float _2296 = _2169._m0[(uint(_2122) * _2112) + 3u].w;
        _2126._m14 = _36(_2296);
        float _2301 = 0.0039215688593685626983642578125;
        vec4 _2302 = vec4(_684._m14, 1.0);
        float _2309 = 1.0 / dot(_2302, _2126._m6);
        vec3 _2315 = vec3(dot(_2302, _2126._m4) * _2309, dot(_2302, _2126._m5) * _2309, dot(_2302, _2126._m3));
        uint _2333 = _2126._m1;
        uint _2336 = _1053;
        _2336 |= 64u;
        float _2340 = _2315.x;
        float _2343 = _2315.y;
        float _2346 = _2315.z;
        bool _2351 = _52(_2340, _2343, _2346) <= _2301;
        bool _2368;
        if (!_2351)
        {
            float _2355 = _2315.x;
            float _2358 = _2315.y;
            float _2361 = _2315.z;
            _2368 = _47(_2355, _2358, _2361) >= (1.0 - _2301);
        }
        else
        {
            _2368 = _2351;
        }
        bool _2376;
        if (!_2368)
        {
            _2376 = (_2333 & _2336) != 0u;
        }
        else
        {
            _2376 = _2368;
        }
        if (_2376)
        {
            continue;
        }
        if ((_2333 & 3u) == 2u)
        {
            vec2 _2395 = fract((_2315.xy * _705._m8.xy) + _705._m8.zw);
            _2315 = vec3(_2395.x, _2395.y, _2315.z);
        }
        vec3 _2398 = _2126._m0;
        float _2401 = 1.0;
        float _2402 = 1.0;
        vec3 _2403 = vec3(0.0, 0.0, 1.0);
        vec3 _2404 = vec3(0.0, 0.0, 1.0);
        uint _2405 = _2126._m1;
        vec3 _2408 = (_2315 * 2.0) - vec3(1.0);
        vec2 _2413 = _2315.xy;
        vec3 _2416 = _2126._m10.xyz;
        if ((_2405 & 3u) == 2u)
        {
            _2423 = _2416;
        }
        else
        {
            _2423 = normalize(_2398 - _684._m14);
        }
        _2403 = _2423;
        _2403 = _2403;
        float _2440 = dot(_684._m6, _2403);
        float _2435 = _14(_2440);
        bool _2444 = _2435 <= _2301;
        bool _2451;
        if (_2444)
        {
            _2451 = (_2405 & 48u) == 0u;
        }
        else
        {
            _2451 = _2444;
        }
        if (_2451)
        {
            continue;
        }
        uvec2 _2456 = _2126._m7.zw;
        vec4 _2455 = _99(_2456);
        float _2461 = TEXTURE_LOD(_2462, vec4((_2413 * _2455.xy) + _2455.zw, 0.0, 0.0).xy, vec4((_2413 * _2455.xy) + _2455.zw, 0.0, 0.0).w).x;
        float _2488 = _2461 * _2461;
        uint _2492 = _2405 & 3u;
        bool _2497 = _2492 == 1u;
        bool _2509;
        if (!_2497)
        {
            bool _2502 = _2492 == 0u;
            bool _2508;
            if (_2502)
            {
                _2508 = _2126._m8.z != 0.0;
            }
            else
            {
                _2508 = _2502;
            }
            _2509 = _2508;
        }
        else
        {
            _2509 = _2497;
        }
        bool _2495 = _2509;
        if (_2495)
        {
            float _2515 = _2126._m8.w;
            _2512 = _14(_2515);
        }
        else
        {
            _2512 = 0.5;
        }
        float _2510 = _2512;
        bool _2523 = _2492 == 0u;
        bool _2529;
        if (_2523)
        {
            _2529 = _2126._m8.z != 0.0;
        }
        else
        {
            _2529 = _2523;
        }
        if (_2529)
        {
            float _2538 = sqrt(dot(_2408, _2408));
            _2530 = min(0.9921875, _14(_2538));
        }
        else
        {
            _2530 = _2315.z;
        }
        float _2521 = _2530;
        uvec2 _2546 = _2126._m7.xy;
        vec4 _2545 = _99(_2546);
        vec2 _2551 = vec2(_2521, _2510);
        float _2555 = TEXTURE_LOD(_2462, vec4((_2551 * _2545.xy) + _2545.zw, 0.0, 0.0).xy, vec4((_2551 * _2545.xy) + _2545.zw, 0.0, 0.0).w).x;
        _2555 *= _2555;
        _2401 = _2555 * _2488;
        if ((_2405 & 48u) != 0u)
        {
            vec4 _2592 = _2126._m10;
            vec4 _2595 = _2126._m8;
            vec4 _2598 = _2126._m9;
            float _2601 = dot(_684._m14, _2592.xyz) + _2592.w;
            if (_2601 < 0.0)
            {
                continue;
            }
            float _2615 = length(_2592.xyz);
            float _2622 = _2601 * 50.0;
            float _2619 = _14(_2622);
            _2401 *= (_2619 * _2619);
            _2601 /= _2615;
            _2592 /= vec4(_2615);
            vec3 _2636 = reflect(-_684._m13, _684._m6);
            if (dot(_2636, _2592.xyz) > 0.0)
            {
                _2636 = reflect(_2636, _2592.xyz);
            }
            float _2654 = dot(_2636, _2592.xyz);
            float _2659 = _2601 / _2654;
            vec3 _2663 = _684._m14 - (_2636 * _2659);
            vec3 _2670 = _2663 - _2398;
            float _2674 = dot(_2670, _2595.xyz) / _2595.w;
            float _2682 = dot(_2670, _2598.xyz) / _2598.w;
            if ((_2405 & 48u) == 32u)
            {
                vec2 _2695 = vec2(_2674, _2682);
                float _2699 = 1.0 / max(1.0, length(vec2(_2674, _2682)));
                _2674 *= (_2699 * _2595.w);
                _2682 *= (_2699 * _2598.w);
            }
            else
            {
                float _2721 = abs(_2674);
                float _2723 = _2674;
                _2674 = (_14(_2721) * _78(_2723)) * _2595.w;
                float _2732 = abs(_2682);
                float _2734 = _2682;
                _2682 = (_14(_2732) * _78(_2734)) * _2598.w;
            }
            vec3 _2741 = (_2595.xyz * _2674) + (_2598.xyz * _2682);
            _2398 += _2741;
            _2403 = normalize(_2398 - _684._m14);
            _2403 = _2403;
        }
        else
        {
            uint _2761 = (_2126._m14 >> uint(16)) & 255u;
            if (_2761 == 0u)
            {
                vec4 _2770 = _2126._m9;
                if (dot(_2770.xyz, _684._m14) < (_2770.w - _2301))
                {
                    continue;
                }
            }
            else
            {
                if (_2761 == 1u)
                {
                    vec3 _2791 = _2126._m9.xyz;
                    float _2796 = _2126._m9.w;
                    uint _2800 = _36(_2796);
                    vec3 _2795 = (((_93(_2800) * 2.0) - vec3(1.0)) * _2791) + _2398;
                    vec3 _2809 = abs((_684._m14 - _2795) / _2791);
                    float _2817 = _2809.x;
                    float _2820 = _2809.y;
                    float _2823 = _2809.z;
                    if (_47(_2817, _2820, _2823) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2401 <= (_2301 / 256.0))
        {
            continue;
        }
        float _2839 = 1.0;
        if ((_2333 & 4u) != 0u)
        {
            float _2846 = float(_2126._m14 & 255u) / 255.0;
            float _2852 = 0.00999999977648258209228515625;
            vec3 _2854 = _684._m14 + (_684._m6 * _2852);
            uint _2862 = 0u;
            if ((_2333 & 3u) == 0u)
            {
                vec3 _2868 = _2854 - _2126._m2.xyz;
                float _2874 = _2868.x;
                float _2877 = _2868.y;
                float _2880 = _2868.z;
                _2862 = _58(_2874, _2877, _2880);
            }
            else
            {
                if ((_2333 & 3u) == 2u)
                {
                    float _2890 = 0.0;
                    for (; _2862 < 3u; _2862++)
                    {
                        int _2898 = 5;
                        _2901._m0 = _2905._m0[(uint(_2898) * ((_2333 >> uint(22)) + _2862)) + 0u];
                        _2901._m1 = _2905._m0[(uint(_2898) * ((_2333 >> uint(22)) + _2862)) + 1u];
                        _2901._m2 = _2905._m0[(uint(_2898) * ((_2333 >> uint(22)) + _2862)) + 2u];
                        _2901._m3 = _2905._m0[(uint(_2898) * ((_2333 >> uint(22)) + _2862)) + 3u];
                        _2901._m4 = _2905._m0[(uint(_2898) * ((_2333 >> uint(22)) + _2862)) + 4u];
                        vec2 _2962 = vec2(dot(_2854, _2901._m0.xyz) + _2901._m0.w, dot(_2854, _2901._m1.xyz) + _2901._m1.w);
                        _2962 = abs((_2962 * 2.0) - vec2(1.0));
                        bool _2987 = _2962.x < 1.0;
                        bool _2993;
                        if (_2987)
                        {
                            _2993 = _2962.y < 1.0;
                        }
                        else
                        {
                            _2993 = _2987;
                        }
                        if (_2993)
                        {
                            _2890 = (1.0 - max(_2962.x, _2962.y)) * _705._m9.w;
                            break;
                        }
                    }
                    _2862 = min(2u, _2862);
                    uint _3010 = uint(_684._m16.x) ^ (uint(_684._m16.y) << uint(1));
                    if (_705._m10.w > 0.0)
                    {
                        _3022 = uint(_705._m11.x);
                    }
                    else
                    {
                        _3022 = 0u;
                    }
                    _3010 ^= _3022;
                    _2862 += uint(int(((float(_3010 & 3u) * 0.25) + 0.125) > _2890));
                }
            }
            int _3044 = 5;
            _3045._m0 = _2905._m0[(uint(_3044) * ((_2333 >> uint(22)) + _2862)) + 0u];
            _3045._m1 = _2905._m0[(uint(_3044) * ((_2333 >> uint(22)) + _2862)) + 1u];
            _3045._m2 = _2905._m0[(uint(_3044) * ((_2333 >> uint(22)) + _2862)) + 2u];
            _3045._m3 = _2905._m0[(uint(_3044) * ((_2333 >> uint(22)) + _2862)) + 3u];
            _3045._m4 = _2905._m0[(uint(_3044) * ((_2333 >> uint(22)) + _2862)) + 4u];
            vec4 _3101 = vec4((_2854.x * _3045._m0.x) + ((_2854.y * _3045._m0.y) + ((_2854.z * _3045._m0.z) + _3045._m0.w)), (_2854.x * _3045._m1.x) + ((_2854.y * _3045._m1.y) + ((_2854.z * _3045._m1.z) + _3045._m1.w)), (_2854.x * _3045._m2.x) + ((_2854.y * _3045._m2.y) + ((_2854.z * _3045._m2.z) + _3045._m2.w)), (_2854.x * _3045._m3.x) + ((_2854.y * _3045._m3.y) + ((_2854.z * _3045._m3.z) + _3045._m3.w)));
            vec3 _3188 = _3101.xyz / vec3(_3101.w);
            _3101 = vec4(_3188.x, _3188.y, _3188.z, _3101.w);
            bool _3196 = min(_3101.x, _3101.y) > 0.0;
            bool _3205;
            if (_3196)
            {
                _3205 = max(_3101.x, _3101.y) < 1.0;
            }
            else
            {
                _3205 = _3196;
            }
            if (_3205)
            {
                vec2 _3217 = (_3101.xy * _3045._m4.xy) + _3045._m4.zw;
                _3101 = vec4(_3217.x, _3217.y, _3101.z, _3101.w);
                if (false)
                {
                    _2839 = textureLod(_3225, vec3(_3101.xyz.xy, _3101.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3232 = (_3101.xy * _705._m12.xy) + vec2(0.5);
                    vec2 _3241 = floor(_3232);
                    vec2 _3244 = _3232 - _3241;
                    _3241 -= vec2(0.5);
                    vec2 _3251 = vec2(4.0) - (_3244 * 3.0);
                    vec2 _3257 = vec2(7.0);
                    vec2 _3260 = vec2(1.0) + (_3244 * 3.0);
                    vec2 _3265 = (_3241 + (((vec2(3.0) - (_3244 * 2.0)) / _3251) - vec2(2.0))) * _705._m12.zw;
                    vec2 _3280 = (_3241 + ((vec2(3.0) + _3244) / _3257)) * _705._m12.zw;
                    vec2 _3292 = (_3241 + ((_3244 / _3260) + vec2(2.0))) * _705._m12.zw;
                    vec3 _3316 = vec3(_3265.x, _3265.y, _3101.z);
                    _2839 = (_3251.x * _3251.y) * textureLod(_3225, vec3(_3316.xy, _3316.z), 0.0);
                    vec3 _3332 = vec3(_3280.x, _3265.y, _3101.z);
                    _2839 += ((_3257.x * _3251.y) * textureLod(_3225, vec3(_3332.xy, _3332.z), 0.0));
                    vec3 _3350 = vec3(_3292.x, _3265.y, _3101.z);
                    _2839 += ((_3260.x * _3251.y) * textureLod(_3225, vec3(_3350.xy, _3350.z), 0.0));
                    vec3 _3368 = vec3(_3265.x, _3280.y, _3101.z);
                    _2839 += ((_3251.x * _3257.y) * textureLod(_3225, vec3(_3368.xy, _3368.z), 0.0));
                    vec3 _3386 = vec3(_3280.x, _3280.y, _3101.z);
                    _2839 += ((_3257.x * _3257.y) * textureLod(_3225, vec3(_3386.xy, _3386.z), 0.0));
                    vec3 _3404 = vec3(_3292.x, _3280.y, _3101.z);
                    _2839 += ((_3260.x * _3257.y) * textureLod(_3225, vec3(_3404.xy, _3404.z), 0.0));
                    vec3 _3422 = vec3(_3265.x, _3292.y, _3101.z);
                    _2839 += ((_3251.x * _3260.y) * textureLod(_3225, vec3(_3422.xy, _3422.z), 0.0));
                    vec3 _3440 = vec3(_3280.x, _3292.y, _3101.z);
                    _2839 += ((_3257.x * _3260.y) * textureLod(_3225, vec3(_3440.xy, _3440.z), 0.0));
                    vec3 _3458 = vec3(_3292.x, _3292.y, _3101.z);
                    _2839 += ((_3260.x * _3260.y) * textureLod(_3225, vec3(_3458.xy, _3458.z), 0.0));
                    _2839 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2839 = float((_2333 & 3u) == 2u);
            }
            float _3472 = float((_2333 >> uint(16)) & 63u) / 63.0;
            float _3486 = ((_2839 * _3472) + 1.0) - _3472;
            _2839 = _14(_3486);
        }
        uint _3489 = _2126._m12;
        vec3 _3488 = (_114(_3489) * _2839) * _2401;
        _2402 *= _2126._m13;
        vec3 _3501 = _3488;
        vec3 _3503 = _2403;
        float _3510 = dot(_684._m6, _3503);
        float _3505 = _14(_3510);
        vec3 _3516 = _684._m6;
        vec3 _3519 = _684._m13;
        vec3 _3522 = _2403;
        vec3 _3524 = _684._m2;
        float _3527 = abs(_684._m3);
        vec3 _3512 = _127(_3516, _3519, _3522, _3524, _3527);
        _684._m20 += (((_3512 * _2402) * _3501) * _3505);
        vec3 _3541 = mix(_3501, vec3(0.0), bvec3((_2333 & 256u) > 0u));
        _684._m19 += (_3541 * _3505);
    }
    _684._m19 = _684._m19;
    _684._m20 += _684._m10;
    _684._m19 *= _684._m0;
    _684._m21 = _684._m19 + _684._m20;
    if (_994._m11.w > 0.0)
    {
        vec4 _3582 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _3587 = abs(vec2(1.0) / _705._m4.zw);
        vec2 _3593 = ((gl_FragCoord.xy * 1.5) * _705._m4.zw) * (_3587 / vec2(32.0));
        vec4 _3607 = TEXTURE_LOD(_3608, vec4((_3593 * _3582.xy) + (vec2(_705._m13.x * 0.75) * _3582.zw), 0.0, 0.0).xy, vec4((_3593 * _3582.xy) + (vec2(_705._m13.x * 0.75) * _3582.zw), 0.0, 0.0).w);
        float _3651 = (length(_710.xyz) - 10.0) * 2.0;
        float _3644 = 1.0 - _14(_3651);
        float _3654 = 1.0 - dot(_684._m6, normalize(-_710.xyz));
        float _3663 = 2.0;
        _3663 *= ((sin((_705._m13.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _3663 *= _3663;
        _3663 *= _3654;
        _3654 *= _3654;
        float _3683 = (_3654 * _3654) * 9.9999997473787516355514526367188e-05;
        vec3 _3693 = _3607.xyz * _3607.xyz;
        _3607 = vec4(_3693.x, _3693.y, _3693.z, _3607.w);
        vec3 _3696 = _3607.xyz;
        float _3706 = (_3696.x * _3654) + _3683;
        vec3 _3699 = _994._m11.xyz * _14(_3706);
        float _3713 = _3696.x;
        vec3 _3712 = _994._m11.xyz * _14(_3713);
        vec3 _3721 = mix(_3699, _3712, vec3(0.0500000007450580596923828125));
        float _3731 = (0.5 * _3654) + _3683;
        vec3 _3726 = _994._m11.xyz * _14(_3731);
        _3721 /= _705._m14.xyz;
        vec3 _3742 = (_3721 * _994._m11.w) * 0.5;
        _684._m19 += (_3742 * _3644);
    }
    vec2 _3755 = gl_FragCoord.xy * _705._m4.xy;
    _3755.y = 1.0 - _3755.y;
    vec4 _3766 = vec4((_3755.x * 2.0) - 1.0, (_3755.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _3779;
    _3779.x = dot(_3766, _705._m15);
    _3779.y = dot(_3766, _705._m16);
    _3779.z = dot(_3766, _705._m17);
    _3779 /= vec3(dot(_3766, _705._m18));
    float _3802 = SAMPLE_TEXTURE(_3803, _3805.xy * vec2(_994._m12.w)).y;
    vec4 _3822 = vec4(_994._m5.xyz, 1.0);
    vec4 _3823 = _994._m1;
    vec3 _3814;
    _3814.x = _31(_3822, _3823);
    vec4 _3835 = vec4(_994._m5.xyz, 1.0);
    vec4 _3836 = _994._m2;
    _3814.y = _31(_3835, _3836);
    vec4 _3848 = vec4(_994._m5.xyz, 1.0);
    vec4 _3849 = _994._m3;
    _3814.z = _31(_3848, _3849);
    vec3 _3854 = _3814 - _3779;
    float _3858 = (_3802 * _808._m5.x) + (1.0 - _808._m5.x);
    float _3867 = length(_3854) * _3858;
    vec2 _3872 = vec2(6.666666507720947265625, 10.0);
    float _3875 = _3867 - _994._m6.w;
    float _3885 = _3875 * _3872.x;
    float _3880 = _14(_3885);
    float _3892 = _3875 * _3872.y;
    float _3887 = _14(_3892);
    float _3902 = (1.0 - _3887) * _3802;
    vec3 _3894 = _994._m12.xyz * _14(_3902);
    float _3905 = _3880;
    float _3912 = ceil(_3905 - 0.001000000047497451305389404296875);
    float _3907 = _14(_3912);
    float _3916 = _3907 - 9.9999997473787516355514526367188e-05;
    _10(_3916);
    _684._m19 += _3894;
    vec3 _3929 = _684._m19 + _684._m20;
    _3924 = vec4(_3929.x, _3929.y, _3929.z, _3924.w);
    vec3 _3933 = _684._m6;
    bool _3936 = false;
    vec2 _3937 = _157(_3933, _3936);
    _3932 = vec4(_3937.x, _3937.y, _3932.z, _3932.w);
    float _3941 = _684._m2.x;
    float _3945 = _684._m2.y;
    float _3949 = _684._m2.z;
    float _3953 = _684._m3;
    _3940 = vec4(_81(_3941), _81(_3945), _81(_3949), _160(_3953));
    vec3 _3963 = _3924.xyz + _994._m13.xyz;
    _3924 = vec4(_3963.x, _3963.y, _3963.z, _3924.w);
}


