#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require

struct _300
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1079
{
    int _m0;
    int _m1;
};

struct _1082
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _322_324
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _324;

layout(set = 2, binding = 0, std140) uniform _428_430
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _430;

layout(set = 1, binding = 0, std140) uniform _885_887
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
} _887;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1084_1086
{
    _1082 _m0[];
} _1086;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1477_1479
{
    vec4 _m0[];
} _1479;

layout(push_constant, std430) uniform _1473_1475
{
    int _m0;
    int _m1;
} _1475;

layout(set = 3, binding = 3) uniform TEXTURE_2D _457[8];
layout(set = 0, binding = 5) uniform sampler _464;
layout(set = 3, binding = 2) uniform TEXTURE_2D _510[8];
layout(set = 0, binding = 6) uniform sampler _514;
layout(set = 3, binding = 0) uniform TEXTURE_2D _525[8];
layout(set = 0, binding = 7) uniform sampler _529;
layout(set = 3, binding = 1) uniform TEXTURE_2D _540[8];
layout(set = 0, binding = 8) uniform sampler _544;
layout(set = 3, binding = 5) uniform TEXTURE_2D _553[8];
layout(set = 0, binding = 9) uniform sampler _557;
layout(set = 3, binding = 7) uniform TEXTURE_2D _566[8];
layout(set = 0, binding = 10) uniform sampler _570;
layout(set = 3, binding = 4) uniform TEXTURE_2D _579[8];
layout(set = 0, binding = 11) uniform sampler _583;
layout(set = 3, binding = 6) uniform TEXTURE_2D _592[8];
layout(set = 0, binding = 12) uniform sampler _596;
layout(set = 1, binding = 1) uniform SAMPLER_2D _895;
layout(set = 1, binding = 2) uniform SAMPLER_2D _900;
layout(set = 0, binding = 14) uniform SAMPLER_2D _1297;
layout(set = 0, binding = 3) uniform sampler3D _1483;
layout(set = 0, binding = 4) uniform sampler3D _1484;

layout(location = 2) in vec4 _314;
layout(location = 6) in vec4 _329;
layout(location = 3) in vec4 _341;
layout(location = 4) in vec4 _344;
layout(location = 5) in vec4 _347;
layout(location = 10) in vec4 _365;
layout(location = 11) in vec4 _369;
layout(location = 12) in vec4 _373;
layout(location = 14) flat in uvec3 _387;
layout(location = 15) in vec4 _390;
layout(location = 8) in vec4 _905;
layout(location = 0) out vec4 _1346;
layout(location = 1) out vec4 _1357;
layout(location = 2) out vec4 _1365;
layout(location = 3) out vec4 _1399;
layout(location = 9) in vec4 _1418;
layout(location = 13) in vec4 _1421;
layout(location = 4) out vec4 _1455;

float _104;

uvec4 _18(vec4 _17)
{
    return floatBitsToUint(_17);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _21(float _20)
{
    if (_20 <= 0.040449999272823333740234375)
    {
        return _20 / 12.9200000762939453125;
    }
    else
    {
        return pow((_20 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _27(vec3 _26)
{
    float _106 = _26.x;
    vec3 _105;
    _105.x = _21(_106);
    float _112 = _26.y;
    _105.y = _21(_112);
    float _118 = _26.z;
    _105.z = _21(_118);
    return _105;
}

vec3 _30(vec3 _29)
{
    vec3 _127 = _29;
    return _27(_127);
}

float _42(float _38, vec4 _39, float _40, bool _41)
{
    float _136 = _39.w / (_38 + _39.z);
    return _136 * _40;
}

vec3 _47(vec3 _45, bool _46)
{
    vec3 _150 = (_45 * 2.0) - vec3(1.0);
    float _168 = (1.0 - (_150.x * _150.x)) - (_150.y * _150.y);
    _150.z = sqrt(_10(_168));
    if (_46 == false)
    {
        _150.z = -_150.z;
    }
    return _150;
}

vec3 _54(vec3 _52, mat3 _53)
{
    return normalize(vec3(dot(_52, _53[0]), dot(_52, _53[1]), dot(_52, _53[2])));
}

vec3 _60(vec3 _57, mat3 _58, bool _59)
{
    vec3 _205 = _57;
    bool _207 = _59;
    vec3 _204 = _47(_205, _207);
    vec3 _210 = _204;
    mat3 _212 = _58;
    return _54(_210, _212);
}

vec2 _66(vec2 _65)
{
    return (vec2(1.0) - abs(_65.yx)) * vec2((_65.x >= 0.0) ? 1.0 : (-1.0), (_65.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _71(inout vec3 _69, bool _70)
{
    _69 /= vec3((abs(_69.x) + abs(_69.y)) + abs(_69.z));
    vec2 _252;
    if (_69.z >= 0.0)
    {
        _252 = _69.xy;
    }
    else
    {
        vec2 _258 = _69.xy;
        _252 = _66(_258);
    }
    _69 = vec3(_252.x, _252.y, _69.z);
    if (_70)
    {
        vec2 _273 = (_69.xy * 0.5) + vec2(0.5);
        _69 = vec3(_273.x, _273.y, _69.z);
    }
    return _69.xy;
}

float _33(float _32)
{
    return sqrt(_32);
}

float _74(float _73)
{
    float _283 = abs(_73);
    float _280 = _33(_283);
    float _287;
    if (_73 > 0.0)
    {
        _287 = _280;
    }
    else
    {
        _287 = -_280;
    }
    return (_287 * 0.5) + 0.5;
}

void main()
{
    _300 _302 = _300(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _302._m15 = _314;
    _302._m16 = gl_FragCoord;
    _302._m14 = _324._m0.xyz + _329.xyz;
    _302._m13 = normalize(-_329.xyz);
    _302._m17 = mat3(vec3(_341.xyz), vec3(_344.xyz), vec3(_347.xyz));
    _302._m34 = _365;
    _302._m35 = _369;
    _302._m36 = _373;
    uint _377 = 0u;
    vec4 _378 = vec4(0.0);
    vec4 _379 = vec4(0.0);
    vec4 _380 = vec4(0.0);
    vec4 _381 = vec4(0.0);
    vec4 _382 = vec4(0.0);
    uvec3 _385 = _387;
    vec3 _389 = _390.xyz;
    bool _397 = _385.y == 65535u;
    bool _403;
    if (_397)
    {
        _403 = _385.z == 65535u;
    }
    else
    {
        _403 = _397;
    }
    bool _393 = _403;
    bool _404 = !_393;
    bool _407 = _385.z != 65535u;
    uint _411 = _385.x & 7u;
    uint _423;
    if (_324._m12.x == 0.0)
    {
        _423 = _411;
    }
    else
    {
        vec4 _432 = _430._m4;
        uvec4 _427 = _18(_432);
        uint _436 = _427[_411 / 2u];
        uint _441 = 16u * (_411 & 1u);
        _423 = (_436 >> _441) & 65535u;
    }
    uint _450 = _423;
    float _452 = SAMPLE_TEXTURE(SAMPLER_2D(_457[_450], _464), _302._m15.zw).x;
    float _485 = pow(_452, 0.125) - 0.800000011920928955078125;
    vec2 _473 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_485) / 0.20000000298023223876953125));
    vec2 _493 = dFdx(_302._m15.zw) * _473.x;
    vec2 _501 = dFdy(_302._m15.zw) * _473.y;
    vec2 _509 = TEXTURE_GRAD(SAMPLER_2D(_510[_450], _514), _302._m15.zw, _493, _501).yx;
    vec3 _524 = SAMPLE_TEXTURE(SAMPLER_2D(_525[_450], _529), _302._m15.zw).xyz;
    vec3 _537 = vec3(0.039999999105930328369140625);
    _537 = SAMPLE_TEXTURE(SAMPLER_2D(_540[_450], _544), _302._m15.zw).xyz;
    float _552 = 1.0;
    _552 = SAMPLE_TEXTURE(SAMPLER_2D(_553[_450], _557), _302._m15.zw).x;
    float _565 = SAMPLE_TEXTURE(SAMPLER_2D(_566[_450], _570), _302._m15.zw).x;
    float _578 = SAMPLE_TEXTURE(SAMPLER_2D(_579[_450], _583), _302._m15.zw).x;
    vec3 _591 = SAMPLE_TEXTURE(SAMPLER_2D(_592[_450], _596), _302._m15.zw).xyz;
    _380 = vec4(_524.x, _524.y, _524.z, _380.w);
    _380.w = _509.y;
    _381 = vec4(_537.x, _537.y, _537.z, _381.w);
    _381.w = _578;
    _382 = vec4(_382.x, _509.x, _382.z, _509.y);
    _378.x = _565;
    _378.y = _552;
    _378.z = _578;
    _378.w = _452;
    _379 = vec4(_591.x, _591.y, _591.z, _379.w);
    uint _629 = 0u;
    vec4 _630 = vec4(0.0);
    vec4 _631 = vec4(0.0);
    vec4 _632 = vec4(0.0);
    vec4 _633 = vec4(0.0);
    vec4 _634 = vec4(0.0);
    uint _635 = _387.x & 7u;
    uint _645;
    if (_324._m12.x == 0.0)
    {
        _645 = _635;
    }
    else
    {
        vec4 _649 = _430._m4;
        uvec4 _648 = _18(_649);
        uint _653 = _648[_635 / 2u];
        uint _658 = 16u * (_635 & 1u);
        _645 = (_653 >> _658) & 65535u;
    }
    uint _666 = _645;
    vec4 _668 = vec4(_302._m15.xy, 0.0, _430._m5.x);
    vec3 _678 = SAMPLE_TEXTURE1(SAMPLER_2D(_525[_666], _529), _668.xy, _668.w).xyz;
    vec2 _690 = SAMPLE_TEXTURE1(SAMPLER_2D(_510[_666], _514), _668.xy, _668.w).yx;
    vec3 _702 = vec3(0.039999999105930328369140625);
    _702 = SAMPLE_TEXTURE1(SAMPLER_2D(_540[_666], _544), _668.xy, _668.w).xyz;
    float _714 = SAMPLE_TEXTURE1(SAMPLER_2D(_457[_666], _464), _668.xy, _668.w).x;
    float _726 = 1.0;
    _726 = SAMPLE_TEXTURE1(SAMPLER_2D(_553[_666], _557), _668.xy, _668.w).x;
    float _738 = SAMPLE_TEXTURE1(SAMPLER_2D(_566[_666], _570), _668.xy, _668.w).x;
    float _750 = SAMPLE_TEXTURE1(SAMPLER_2D(_579[_666], _583), _668.xy, _668.w).x;
    vec3 _762 = SAMPLE_TEXTURE1(SAMPLER_2D(_592[_666], _596), _668.xy, _668.w).xyz;
    _630 = vec4(_678.x, _678.y, _678.z, _630.w);
    _630.w = _690.y;
    _631 = vec4(_702.x, _702.y, _702.z, _631.w);
    _631.w = _750;
    _632 = vec4(_632.x, _690.x, _632.z, _690.y);
    _633.x = _738;
    _633.y = _726;
    _633.z = _750;
    _633.w = _714;
    _634 = vec4(_762.x, _762.y, _762.z, _634.w);
    _302._m8 = _632.wyz;
    float _809 = _378.y * _430._m6.x;
    _302._m4 = _10(_809);
    float _816;
    if (_430._m7.x > 0.0)
    {
        _816 = _381.x;
    }
    else
    {
        _816 = 0.0;
    }
    _302._m5 = _816;
    vec3 _827;
    if (_430._m7.x > 0.0)
    {
        _827 = vec3(_381.y);
    }
    else
    {
        _827 = _381.xyz;
    }
    _381 = vec4(_827.x, _827.y, _827.z, _381.w);
    float _845 = (1.0 - _302._m4) * _430._m8.x;
    _302._m12 = _10(_845);
    _302._m10 = vec3(_378.x) * _389;
    _302._m10 *= vec3(_324._m13.x);
    _302._m0 = _380.xyz;
    _302._m2 = _381.xyz;
    _302._m1 = _379.xyz;
    _302._m9 = _378.xyz;
    _302._m3 = _378.w;
    _302._m6 = _382.wyz;
    vec2 _882 = _314.xy * _887._m33.xy;
    vec4 _893 = SAMPLE_TEXTURE(_895, _882);
    vec4 _899 = SAMPLE_TEXTURE(_900, _882);
    float _910 = _905.x * 0.5;
    float _904 = 1.0 - _10(_910);
    float _916 = _904 * 2.0;
    float _923 = (_10(_916) - (1.0 - _893.w)) * 1.0;
    float _913 = _10(_923);
    float _932 = (_904 - (1.0 - _899.w)) * 1.0;
    float _925 = _10(_932);
    vec3 _936 = _893.xyz;
    _302._m0 = mix(_302._m0, _30(_936), vec3(_913));
    _302._m2 = mix(_302._m2, vec3(0.0199999995529651641845703125), vec3(_913));
    _302._m3 = mix(_302._m3, 0.64999997615814208984375, _913);
    _302._m6 = mix(_302._m6, _899.xyz, vec3(_925));
    uint _966 = uint((_887._m34.x > 0.0) ? 8 : 0);
    float _972 = 16.0;
    float _974 = 8.0;
    float _976 = 24.0;
    vec2 _985 = _302._m16.xy * _324._m14.xy;
    vec3 _978;
    _978 = vec3(_985.x, _985.y, _978.z);
    _978.y = 1.0 - _978.y;
    vec2 _998 = floor(_978.xy * vec2(_972, _974));
    _978 = vec3(_998.x, _998.y, _978.z);
    float _1002 = _302._m16.z;
    vec4 _1005 = _324._m15;
    float _1008 = 1.0;
    bool _1009 = false;
    float _1001 = _42(_1002, _1005, _1008, _1009);
    float _1011 = log2(max(1.0, _1001 / _324._m16.z)) * _324._m16.w;
    _978.z = min(_976 - 1.0, floor(_1011));
    uint _1027 = uint((_978.x + (_978.y * _972)) + ((_978.z * _972) * _974));
    bool _1043 = true;
    vec3 _1045 = _302._m6;
    bool _1048 = _1043;
    _302._m7 = _47(_1045, _1048);
    vec3 _1052 = _302._m7;
    mat3 _1055 = _302._m17;
    _302._m6 = _54(_1052, _1055);
    vec3 _1060 = _302._m8;
    mat3 _1063 = _302._m17;
    bool _1066 = _1043;
    _302._m8 = _60(_1060, _1063, _1066);
    uint _1070 = 0u;
    uint _1071 = 0u;
    uint _1072 = 0u;
    uint _1073 = 0u;
    uint _1074 = 0u;
    uint _1075 = 0u;
    int _1077 = 256;
    _1079 _1081;
    _1081._m0 = _1086._m0[_1027]._m0;
    _1081._m1 = _1086._m0[_1027]._m1;
    int _1095 = _1081._m0 & (~(_1081._m0 >> 31));
    int _1104 = _1081._m1 & (~(_1081._m1 >> 31));
    _1070 = uint((_1095 >> 16) * _1077);
    _1071 = _1070 + uint(_1104 & 255);
    _1072 = _1070;
    _1073 = _1072 + uint((_1104 >> 8) & 255);
    _1074 = _1070;
    _1075 = _1074 + uint((_1104 >> 16) & 255);
    vec3 _1137 = vec3(0.0);
    vec3 _1138 = vec3(_302._m34.x, _302._m34.y, _302._m34.z);
    vec3 _1146 = vec3(_302._m34.w, _302._m35.x, _302._m35.y);
    vec3 _1154 = vec3(_302._m35.z, _302._m35.w, _302._m36.x);
    vec3 _1162 = vec3(_302._m36.y, _302._m36.z, _302._m36.w);
    vec3 _1170 = ((_1138 - (_1146 * _302._m6.y)) + (_1154 * _302._m6.z)) - (_1162 * _302._m6.x);
    float _1193 = _887._m35.x * _324._m17.x;
    _1137 += max(_1170 * _10(_1193), vec3(0.0));
    vec3 _1199 = vec3(0.0);
    vec3 _1200 = vec3(_302._m34.x, _302._m34.y, _302._m34.z);
    vec3 _1208 = vec3(_302._m34.w, _302._m35.x, _302._m35.y);
    vec3 _1216 = vec3(_302._m35.z, _302._m35.w, _302._m36.x);
    vec3 _1224 = vec3(_302._m36.y, _302._m36.z, _302._m36.w);
    vec3 _1232 = ((_1200 - (_1208 * _302._m8.y)) + (_1216 * _302._m8.z)) - (_1224 * _302._m8.x);
    float _1255 = _887._m35.x * _324._m17.x;
    _1199 += max(_1232 * _10(_1255), vec3(0.0));
    _1137 = mix(_1137, _1199, vec3(_302._m4));
    float _1272;
    if (dot(_302._m10, vec3(1.0)) > 0.0)
    {
        _1272 = -_302._m3;
    }
    else
    {
        _1272 = _302._m3;
    }
    _302._m3 = _1272;
    _302._m18 = _1137;
    if (_887._m36.x < 1.0)
    {
        vec2 _1291 = gl_FragCoord.xy * 0.00390625;
        float _1296 = TEXTURE_LOD(_1297, vec4(_314.xy * _430._m9.xy, 0.0, 0.0).xy, vec4(_314.xy * _430._m9.xy, 0.0, 0.0).w).x;
        float _1330 = abs(clamp((_887._m36.x - (_1296 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _1296 = _10(_1330);
        _1296 *= 600.0;
        _302._m19 += (vec3(_1296) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _1354 = (_302._m18 * _302._m0) + _302._m10;
    _1346 = vec4(_1354.x, _1354.y, _1354.z, _1346.w);
    vec3 _1358 = _302._m6;
    bool _1361 = false;
    vec2 _1362 = _71(_1358, _1361);
    _1357 = vec4(_1362.x, _1362.y, _1357.z, _1357.w);
    float _1366 = _302._m2.x;
    float _1370 = _302._m2.y;
    float _1374 = _302._m2.z;
    float _1378 = _302._m3;
    _1365 = vec4(_33(_1366), _33(_1370), _33(_1374), _74(_1378));
    uint _1383 = uint((_887._m34.x > 0.0) ? 8 : 0);
    uint _1389 = uint(int(_1383 > 0u));
    _1389 |= 2u;
    _1389 |= 4u;
    float _1400 = _302._m0.x;
    float _1404 = _302._m0.y;
    float _1408 = _302._m0.z;
    _1399 = vec4(_33(_1400), _33(_1404), _33(_1408), float(_1389) / 255.0);
    vec4 _1417 = _1418;
    vec4 _1420 = _1421;
    vec2 _1423 = ((_1417.xy / vec2(_1417.w)) * 0.5) + vec2(0.5);
    vec2 _1433 = ((_1420.xy / vec2(_1420.w)) * 0.5) + vec2(0.5);
    _1423.y = 1.0 - _1423.y;
    _1433.y = 1.0 - _1433.y;
    vec2 _1451 = _324._m18.xy;
    _1455 = vec4((_1423 - _1433) * _1451, 0.0, 1.0);
    vec3 _1470 = _1346.xyz + _887._m37.xyz;
    _1346 = vec4(_1470.x, _1470.y, _1470.z, _1346.w);
}

