#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _340
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _609
{
    int _m0;
    int _m1;
};

struct _612
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _362_364
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
} _364;

layout(set = 2, binding = 0, std140) uniform _448_450
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _450;

layout(set = 1, binding = 0, std140) uniform _498_500
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _500;

layout(set = 0, binding = 4, std430) restrict readonly buffer _614_616
{
    _612 _m0[];
} _616;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1078_1080
{
    vec4 _m0[];
} _1080;

layout(push_constant, std430) uniform _1074_1076
{
    int _m0;
    int _m1;
} _1076;

layout(set = 2, binding = 1) uniform SAMPLER_2D _445;
layout(set = 2, binding = 2) uniform SAMPLER_2D _474;
layout(set = 2, binding = 3) uniform SAMPLER_2D _801;
layout(set = 2, binding = 4) uniform SAMPLER_2D _1052;
layout(set = 0, binding = 2) uniform sampler3D _1084;
layout(set = 0, binding = 3) uniform sampler3D _1085;

layout(location = 2) in vec4 _354;
layout(location = 6) in vec4 _370;
layout(location = 3) in vec4 _382;
layout(location = 4) in vec4 _385;
layout(location = 5) in vec4 _388;
layout(location = 10) in vec4 _406;
layout(location = 11) in vec4 _410;
layout(location = 12) in vec4 _414;
layout(location = 7) in vec4 _803;
layout(location = 0) out vec4 _924;
layout(location = 1) out vec4 _935;
layout(location = 2) out vec4 _943;
layout(location = 3) out vec4 _977;
layout(location = 9) in vec4 _996;
layout(location = 13) in vec4 _999;
layout(location = 4) out vec4 _1034;

float _122;

float _24(float _23)
{
    if (_23 <= 0.040449999272823333740234375)
    {
        return _23 / 12.9200000762939453125;
    }
    else
    {
        return pow((_23 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _30(vec3 _29)
{
    float _124 = _29.x;
    vec3 _123;
    _123.x = _24(_124);
    float _131 = _29.y;
    _123.y = _24(_131);
    float _137 = _29.z;
    _123.z = _24(_137);
    return _123;
}

vec4 _34(vec4 _33)
{
    vec3 _147 = _33.xyz;
    vec4 _146 = vec4(_30(_147), 1.0);
    float _155 = _33.w;
    _146.w = _24(_155);
    return _146;
}

vec4 _37(vec4 _36)
{
    vec4 _164 = _36;
    return _34(_164);
}

vec4 _53(SAMPLER_2D _51, vec2 _52)
{
    vec4 _178 = SAMPLE_TEXTURE(_51, _52);
    vec4 _182 = _178;
    _178 = _37(_182);
    return _178;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

float _62(float _58, vec4 _59, float _60, bool _61)
{
    float _188 = _59.w / (_58 + _59.z);
    return _188 * _60;
}

vec3 _67(vec3 _65, bool _66)
{
    vec3 _201 = (_65 * 2.0) - vec3(1.0);
    float _219 = (1.0 - (_201.x * _201.x)) - (_201.y * _201.y);
    _201.z = sqrt(_14(_219));
    if (_66 == false)
    {
        _201.z = -_201.z;
    }
    return _201;
}

vec3 _74(vec3 _72, mat3 _73)
{
    return normalize(vec3(dot(_72, _73[0]), dot(_72, _73[1]), dot(_72, _73[2])));
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

vec2 _78(vec2 _77)
{
    return (vec2(1.0) - abs(_77.yx)) * vec2((_77.x >= 0.0) ? 1.0 : (-1.0), (_77.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _83(inout vec3 _81, bool _82)
{
    _81 /= vec3((abs(_81.x) + abs(_81.y)) + abs(_81.z));
    vec2 _290;
    if (_81.z >= 0.0)
    {
        _290 = _81.xy;
    }
    else
    {
        vec2 _296 = _81.xy;
        _290 = _78(_296);
    }
    _81 = vec3(_290.x, _290.y, _81.z);
    if (_82)
    {
        vec2 _311 = (_81.xy * 0.5) + vec2(0.5);
        _81 = vec3(_311.x, _311.y, _81.z);
    }
    return _81.xy;
}

float _43(float _42)
{
    return sqrt(_42);
}

float _86(float _85)
{
    float _321 = abs(_85);
    float _318 = _43(_321);
    float _325;
    if (_85 > 0.0)
    {
        _325 = _318;
    }
    else
    {
        _325 = -_318;
    }
    return (_325 * 0.5) + 0.5;
}

float _40(float _39)
{
    return _39 * _39;
}

void main()
{
    float _337 = 0.0;
    _340 _342 = _340(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _342._m15 = _354;
    _342._m16 = gl_FragCoord;
    _342._m14 = _364._m4.xyz + _370.xyz;
    _342._m13 = normalize(-_370.xyz);
    _342._m17 = mat3(vec3(_382.xyz), vec3(_385.xyz), vec3(_388.xyz));
    _342._m34 = _406;
    _342._m35 = _410;
    _342._m36 = _414;
    uint _418 = 0u;
    vec4 _419 = vec4(0.0);
    vec4 _420 = vec4(0.0);
    vec4 _421 = vec4(0.0);
    vec4 _422 = vec4(0.0);
    vec4 _423 = vec4(0.0);
    _342._m0 = _421.xyz;
    _342._m2 = _422.xyz;
    _342._m1 = _420.xyz;
    _342._m9 = _419.xyz;
    _342._m3 = _419.w;
    _342._m6 = _423.wyz;
    vec2 _455 = _354.xy * _450._m4.xy;
    float _460 = _53(_445, _455).x * 4.0;
    _337 = _14(_460);
    _342._m2 = _450._m5.xxx;
    _342._m3 = _450._m5.y;
    _342._m6 = vec3(0.5, 0.5, 1.0);
    vec4 _490 = SAMPLE_TEXTURE1(_474, vec4(_354.xy, 0.0, -2.0).xy, vec4(_354.xy, 0.0, -2.0).w);
    vec3 _473 = _37(_490).xyz;
    _342._m0 = _473;
    _342._m11 = 1.0;
    uint _497 = uint((_500._m15.x > 0.0) ? 8 : 0);
    float _507 = 16.0;
    float _509 = 8.0;
    float _511 = 24.0;
    vec2 _520 = _342._m16.xy * _364._m16.xy;
    vec3 _513;
    _513 = vec3(_520.x, _520.y, _513.z);
    _513.y = 1.0 - _513.y;
    vec2 _533 = floor(_513.xy * vec2(_507, _509));
    _513 = vec3(_533.x, _533.y, _513.z);
    float _537 = _342._m16.z;
    vec4 _540 = _364._m17;
    float _543 = 1.0;
    bool _544 = false;
    float _536 = _62(_537, _540, _543, _544);
    float _546 = log2(max(1.0, _536 / _364._m18.z)) * _364._m18.w;
    _513.z = min(_511 - 1.0, floor(_546));
    uint _563 = uint((_513.x + (_513.y * _507)) + ((_513.z * _507) * _509));
    bool _579 = true;
    _579 = gl_FrontFacing;
    vec3 _585 = _342._m6;
    bool _588 = _579;
    _342._m7 = _67(_585, _588);
    vec3 _592 = _342._m7;
    mat3 _595 = _342._m17;
    _342._m6 = _74(_592, _595);
    uint _600 = 0u;
    uint _601 = 0u;
    uint _602 = 0u;
    uint _603 = 0u;
    uint _604 = 0u;
    uint _605 = 0u;
    int _607 = 256;
    _609 _611;
    _611._m0 = _616._m0[_563]._m0;
    _611._m1 = _616._m0[_563]._m1;
    int _625 = _611._m0 & (~(_611._m0 >> 31));
    int _634 = _611._m1 & (~(_611._m1 >> 31));
    _600 = uint((_625 >> 16) * _607);
    _601 = _600 + uint(_634 & 255);
    _602 = _600;
    _603 = _602 + uint((_634 >> 8) & 255);
    _604 = _600;
    _605 = _604 + uint((_634 >> 16) & 255);
    vec3 _667 = vec3(0.0);
    vec3 _668 = vec3(_342._m34.x, _342._m34.y, _342._m34.z);
    vec3 _676 = vec3(_342._m34.w, _342._m35.x, _342._m35.y);
    vec3 _684 = vec3(_342._m35.z, _342._m35.w, _342._m36.x);
    vec3 _692 = vec3(_342._m36.y, _342._m36.z, _342._m36.w);
    vec3 _700 = ((_668 - (_676 * _342._m6.y)) + (_684 * _342._m6.z)) - (_692 * _342._m6.x);
    float _724 = _500._m16.x * _364._m19.x;
    _667 += max(_700 * _14(_724), vec3(0.0));
    float _736;
    if (dot(_342._m10, vec3(1.0)) > 0.0)
    {
        _736 = -_342._m3;
    }
    else
    {
        _736 = _342._m3;
    }
    _342._m3 = _736;
    _342._m18 = _667;
    vec2 _749 = gl_FragCoord.xy * _364._m16.xy;
    _749.y = 1.0 - _749.y;
    vec4 _760 = vec4((_749.x * 2.0) - 1.0, (_749.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _773;
    _773.x = dot(_760, _364._m20);
    _773.y = dot(_760, _364._m21);
    _773.z = dot(_760, _364._m22);
    _773 /= vec3(dot(_760, _364._m23));
    float _800 = SAMPLE_TEXTURE(_801, _803.xy * vec2(_500._m17.w)).y;
    vec4 _820 = vec4(_500._m13.xyz, 1.0);
    vec4 _821 = _500._m1;
    vec3 _812;
    _812.x = _21(_820, _821);
    vec4 _833 = vec4(_500._m13.xyz, 1.0);
    vec4 _834 = _500._m2;
    _812.y = _21(_833, _834);
    vec4 _846 = vec4(_500._m13.xyz, 1.0);
    vec4 _847 = _500._m3;
    _812.z = _21(_846, _847);
    vec3 _852 = _812 - _773;
    float _856 = (_800 * _450._m6.x) + (1.0 - _450._m6.x);
    float _865 = length(_852) * _856;
    vec2 _870 = vec2(6.666666507720947265625, 10.0);
    float _874 = _865 - _500._m14.w;
    float _884 = _874 * _870.x;
    float _879 = _14(_884);
    float _891 = _874 * _870.y;
    float _886 = _14(_891);
    float _901 = (1.0 - _886) * _800;
    vec3 _893 = _500._m17.xyz * _14(_901);
    float _904 = _879;
    float _911 = ceil(_904 - 0.001000000047497451305389404296875);
    float _906 = _14(_911);
    float _916 = _906 - 9.9999997473787516355514526367188e-05;
    _10(_916);
    _342._m19 += _893;
    vec3 _932 = (_342._m18 * _342._m0) + _342._m10;
    _924 = vec4(_932.x, _932.y, _932.z, _924.w);
    vec3 _936 = _342._m6;
    bool _939 = false;
    vec2 _940 = _83(_936, _939);
    _935 = vec4(_940.x, _940.y, _935.z, _935.w);
    float _944 = _342._m2.x;
    float _948 = _342._m2.y;
    float _952 = _342._m2.z;
    float _956 = _342._m3;
    _943 = vec4(_43(_944), _43(_948), _43(_952), _86(_956));
    uint _961 = uint((_500._m15.x > 0.0) ? 8 : 0);
    uint _967 = uint(int(_961 > 0u));
    _967 |= 2u;
    _967 |= 4u;
    float _978 = _342._m0.x;
    float _982 = _342._m0.y;
    float _986 = _342._m0.z;
    _977 = vec4(_43(_978), _43(_982), _43(_986), float(_967) / 255.0);
    vec4 _995 = _996;
    vec4 _998 = _999;
    vec2 _1001 = ((_995.xy / vec2(_995.w)) * 0.5) + vec2(0.5);
    vec2 _1011 = ((_998.xy / vec2(_998.w)) * 0.5) + vec2(0.5);
    _1001.y = 1.0 - _1001.y;
    _1011.y = 1.0 - _1011.y;
    vec2 _1029 = _364._m24.xy;
    _1034 = vec4((_1001 - _1011) * _1029, 0.0, 1.0);
    vec3 _1048 = _924.xyz + _500._m18.xyz;
    _924 = vec4(_1048.x, _1048.y, _1048.z, _924.w);
    float _1057 = SAMPLE_TEXTURE(_1052, _354.xy).x;
    float _1060 = _450._m5.z;
    float _1065 = mix(1.0, _40(_1057), _14(_1060));
    float _1051 = _14(_1065);
    vec3 _1071 = _924.xyz * vec3(_1051);
    _924 = vec4(_1071.x, _1071.y, _1071.z, _924.w);
}

