#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _531
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1054
{
    int _m0;
    int _m1;
};

struct _1057
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _554_556
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _556;

layout(set = 2, binding = 0, std140) uniform _708_710
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _710;

layout(set = 1, binding = 0, std140) uniform _872_874
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _874;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1059_1061
{
    _1057 _m0[];
} _1061;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1327_1329
{
    vec4 _m0[];
} _1329;

layout(push_constant, std430) uniform _1323_1325
{
    int _m0;
    int _m1;
} _1325;

layout(set = 2, binding = 1) uniform SAMPLER_2D _688;
layout(set = 2, binding = 2) uniform SAMPLER_2D _825;
layout(set = 1, binding = 1) uniform SAMPLER_2D _881;
layout(set = 1, binding = 2) uniform SAMPLER_2D _886;
layout(set = 3, binding = 0) uniform TEXTURE_2D _1315[8];
layout(set = 3, binding = 1) uniform TEXTURE_2D _1316[8];
layout(set = 3, binding = 2) uniform TEXTURE_2D _1317[8];
layout(set = 3, binding = 3) uniform TEXTURE_2D _1318[8];
layout(set = 3, binding = 4) uniform TEXTURE_2D _1319[8];
layout(set = 3, binding = 5) uniform TEXTURE_2D _1320[8];
layout(set = 3, binding = 6) uniform TEXTURE_2D _1321[8];
layout(set = 3, binding = 7) uniform TEXTURE_2D _1322[8];
layout(set = 0, binding = 3) uniform sampler3D _1333;
layout(set = 0, binding = 4) uniform sampler3D _1334;

layout(location = 2) in vec4 _546;
layout(location = 6) in vec4 _561;
layout(location = 3) in vec4 _573;
layout(location = 4) in vec4 _576;
layout(location = 5) in vec4 _579;
layout(location = 10) in vec4 _597;
layout(location = 11) in vec4 _601;
layout(location = 12) in vec4 _605;
layout(location = 8) in vec4 _891;
layout(location = 0) out vec4 _1235;
layout(location = 1) out vec4 _1246;
layout(location = 2) out vec4 _1254;
layout(location = 3) out vec4 _1285;

float _146;

float _40(float _39)
{
    return _39 * _39;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _25(float _24)
{
    return _24 * ((_24 * ((_24 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _28(vec3 _27)
{
    float _184 = _27.x;
    vec3 _183;
    _183.x = _25(_184);
    float _189 = _27.y;
    _183.y = _25(_189);
    float _194 = _27.z;
    _183.z = _25(_194);
    return _183;
}

vec4 _34(vec4 _33)
{
    vec3 _203 = _33.xyz;
    vec4 _202 = vec4(_28(_203), 1.0);
    float _211 = _33.w;
    _202.w = _25(_211);
    return _202;
}

vec4 _58(SAMPLER_2D _56, vec2 _57)
{
    vec4 _239 = SAMPLE_TEXTURE(_56, _57);
    vec4 _243 = _239;
    _239 = _34(_243);
    return _239;
}

float _62(vec3 _61)
{
    return dot(_61, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _89(vec3 _87, bool _88)
{
    vec3 _380 = (_87 * 2.0) - vec3(1.0);
    float _398 = (1.0 - (_380.x * _380.x)) - (_380.y * _380.y);
    _380.z = sqrt(_10(_398));
    if (_88 == false)
    {
        _380.z = -_380.z;
    }
    return _380;
}

vec3 _96(vec3 _94, mat3 _95)
{
    return normalize(vec3(dot(_94, _95[0]), dot(_94, _95[1]), dot(_94, _95[2])));
}

vec3 _102(vec3 _99, mat3 _100, bool _101)
{
    vec3 _435 = _99;
    bool _437 = _101;
    vec3 _434 = _89(_435, _437);
    vec3 _440 = _434;
    mat3 _442 = _100;
    return _96(_440, _442);
}

float _19(float _18)
{
    if (_18 <= 0.040449999272823333740234375)
    {
        return _18 / 12.9200000762939453125;
    }
    else
    {
        return pow((_18 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _22(vec3 _21)
{
    float _148 = _21.x;
    vec3 _147;
    _147.x = _19(_148);
    float _155 = _21.y;
    _147.y = _19(_155);
    float _161 = _21.z;
    _147.z = _19(_161);
    return _147;
}

vec3 _37(vec3 _36)
{
    vec3 _220 = _36;
    return _22(_220);
}

float _84(float _80, vec4 _81, float _82, bool _83)
{
    float _367 = _81.w / (_80 + _81.z);
    return _367 * _82;
}

float _45(float _43, float _44)
{
    return pow(_43, _44);
}

vec3 _67(vec3 _65, float _66)
{
    float _264 = 50.0 * dot(_65, vec3(0.33329999446868896484375));
    float _257 = _10(_264);
    float _273 = 1.0 - _66;
    float _276 = _10(_273);
    float _277 = 5.0;
    vec3 _281 = _65 + ((vec3(_257) - _65) * _45(_276, _277));
    return _16(_281);
}

vec3 _75(vec3 _70, vec3 _71, vec3 _72, vec3 _73, float _74)
{
    vec3 _285 = normalize(_71 + _72);
    float _290 = 1.0 - (_74 * 0.800000011920928955078125);
    _290 *= _290;
    _290 *= _290;
    float _301 = _290 * _290;
    float _309 = dot(_70, _285);
    float _305 = _10(_309);
    float _311 = ((_305 * _305) * (_301 - 1.0)) + 1.0;
    _311 = _301 / ((_311 * _311) + 9.9999999392252902907785028219223e-09);
    float _330 = dot(_70, _71);
    float _326 = (_10(_330) * (1.0 - _290)) + _290;
    float _341 = dot(_70, _72);
    float _337 = (_10(_341) * (1.0 - _290)) + _290;
    _311 /= (((4.0 * _326) * _337) + 9.9999999392252902907785028219223e-09);
    vec3 _359 = _73;
    float _361 = dot(_72, _285);
    return _67(_359, _361) * _311;
}

vec2 _106(vec2 _105)
{
    return (vec2(1.0) - abs(_105.yx)) * vec2((_105.x >= 0.0) ? 1.0 : (-1.0), (_105.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _111(inout vec3 _109, bool _110)
{
    _109 /= vec3((abs(_109.x) + abs(_109.y)) + abs(_109.z));
    vec2 _482;
    if (_109.z >= 0.0)
    {
        _482 = _109.xy;
    }
    else
    {
        vec2 _488 = _109.xy;
        _482 = _106(_488);
    }
    _109 = vec3(_482.x, _482.y, _109.z);
    if (_110)
    {
        vec2 _503 = (_109.xy * 0.5) + vec2(0.5);
        _109 = vec3(_503.x, _503.y, _109.z);
    }
    return _109.xy;
}

float _48(float _47)
{
    return sqrt(_47);
}

float _114(float _113)
{
    float _513 = abs(_113);
    float _510 = _48(_513);
    float _517;
    if (_113 > 0.0)
    {
        _517 = _510;
    }
    else
    {
        _517 = -_510;
    }
    return (_517 * 0.5) + 0.5;
}

void main()
{
    _531 _533 = _531(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _531 _543 = _531(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _543._m15 = _546;
    _543._m16 = gl_FragCoord;
    _543._m14 = _556._m0.xyz + _561.xyz;
    _543._m13 = normalize(-_561.xyz);
    _543._m17 = mat3(vec3(_573.xyz), vec3(_576.xyz), vec3(_579.xyz));
    _543._m34 = _597;
    _543._m35 = _601;
    _543._m36 = _605;
    uint _609 = 0u;
    vec4 _610 = vec4(0.0);
    vec4 _611 = vec4(0.0);
    vec4 _612 = vec4(0.0);
    vec4 _613 = vec4(0.0);
    vec4 _614 = vec4(0.0);
    _543._m0 = _612.xyz;
    _543._m2 = _613.xyz;
    _543._m1 = _611.xyz;
    _543._m9 = _610.xyz;
    _543._m3 = _610.w;
    _543._m6 = _614.wyz;
    _543._m12 = 0.0;
    mat3 _638 = transpose(_543._m17);
    vec3 _642 = normalize(vec3(dot(_543._m13, _638[0]), dot(_543._m13, _638[1]), dot(_543._m13, _638[2])));
    vec2 _660 = _546.xy;
    int _664 = 8;
    vec3 _666 = vec3(-_642.xy, 1.0);
    vec3 _673 = _666 / vec3(float(_664));
    vec3 _679 = vec3(_660, 0.0);
    vec2 _684 = _679.xy;
    float _703 = TEXTURE_LOD(_688, vec4(_679.xy, 0.0, 0.0).xy, vec4(_679.xy, 0.0, 0.0).w).w;
    float _687 = _40(_703);
    float _706 = _687 * _710._m2.x;
    float _715 = _706;
    int _717 = 0;
    for (;;)
    {
        bool _725 = _717 < _664;
        bool _732;
        if (_725)
        {
            _732 = _679.z < _706;
        }
        else
        {
            _732 = _725;
        }
        if (_732)
        {
            _684 = _679.xy;
            _715 = _706;
            _679 += _673;
            float _753 = TEXTURE_LOD(_688, vec4(_679.xy, 0.0, 0.0).xy, vec4(_679.xy, 0.0, 0.0).w).w;
            _706 = _40(_753) * _710._m2.x;
            _717++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _761 = _706 - _679.z;
    float _766 = (_715 - _679.z) + _673.z;
    float _780 = _761 / (_761 - _766);
    float _774 = _10(_780);
    vec2 _782 = mix(_679.xy, _684, vec2(_774));
    vec2 _790 = _782;
    vec4 _789 = _58(_688, _790);
    _533._m0 = _789.xyz;
    vec3 _798 = _789.xyz;
    vec3 _813 = (_789.www * _710._m3.w) * 8.0;
    _543._m0 = mix(_789.xyz, _710._m3.xyz * _62(_798), _16(_813));
    _543._m2 = _710._m4.xxx;
    _543._m3 = _710._m4.y;
    _543._m6 = SAMPLE_TEXTURE(_825, _660).xyz;
    vec3 _834 = _533._m0;
    _533._m2 = _710._m4.zzz * _62(_834);
    _533._m3 = _710._m4.w;
    _533._m6 = vec3(1.0) - SAMPLE_TEXTURE1(_825, vec4(_782, 0.0, 0.0).xy, vec4(_782, 0.0, 0.0).w).xyz;
    vec3 _860 = _533._m6;
    mat3 _863 = _543._m17;
    bool _866 = true;
    _533._m6 = _102(_860, _863, _866);
    vec2 _869 = _546.xy * _874._m25.xy;
    vec4 _880 = SAMPLE_TEXTURE(_881, _869);
    vec4 _885 = SAMPLE_TEXTURE(_886, _869);
    float _896 = _891.x * 0.5;
    float _890 = 1.0 - _10(_896);
    float _902 = _890 * 2.0;
    float _909 = (_10(_902) - (1.0 - _880.w)) * 1.0;
    float _899 = _10(_909);
    float _918 = (_890 - (1.0 - _885.w)) * 1.0;
    float _911 = _10(_918);
    vec3 _922 = _880.xyz;
    _543._m0 = mix(_543._m0, _37(_922), vec3(_899));
    _543._m2 = mix(_543._m2, vec3(0.0199999995529651641845703125), vec3(_899));
    _543._m3 = mix(_543._m3, 0.64999997615814208984375, _899);
    _543._m6 = mix(_543._m6, _885.xyz, vec3(_911));
    uint _952 = uint((_874._m26.x > 0.0) ? 8 : 0);
    float _959 = 16.0;
    float _961 = 8.0;
    float _962 = 24.0;
    vec2 _971 = _543._m16.xy * _556._m2.xy;
    vec3 _964;
    _964 = vec3(_971.x, _971.y, _964.z);
    _964.y = 1.0 - _964.y;
    vec2 _984 = floor(_964.xy * vec2(_959, _961));
    _964 = vec3(_984.x, _984.y, _964.z);
    float _988 = _543._m16.z;
    vec4 _991 = _556._m3;
    float _994 = 1.0;
    bool _995 = false;
    float _987 = _84(_988, _991, _994, _995);
    float _997 = log2(max(1.0, _987 / _556._m4.z)) * _556._m4.w;
    _964.z = min(_962 - 1.0, floor(_997));
    uint _1013 = uint((_964.x + (_964.y * _959)) + ((_964.z * _959) * _961));
    bool _1029 = true;
    vec3 _1031 = _543._m6;
    bool _1034 = _1029;
    _543._m7 = _89(_1031, _1034);
    vec3 _1038 = _543._m7;
    mat3 _1041 = _543._m17;
    _543._m6 = _96(_1038, _1041);
    uint _1046 = 0u;
    uint _1047 = 0u;
    uint _1048 = 0u;
    uint _1049 = 0u;
    uint _1050 = 0u;
    uint _1051 = 0u;
    int _1052 = 256;
    _1054 _1056;
    _1056._m0 = _1061._m0[_1013]._m0;
    _1056._m1 = _1061._m0[_1013]._m1;
    int _1070 = _1056._m0 & (~(_1056._m0 >> 31));
    int _1079 = _1056._m1 & (~(_1056._m1 >> 31));
    _1046 = uint((_1070 >> 16) * _1052);
    _1047 = _1046 + uint(_1079 & 255);
    _1048 = _1046;
    _1049 = _1048 + uint((_1079 >> 8) & 255);
    _1050 = _1046;
    _1051 = _1050 + uint((_1079 >> 16) & 255);
    vec3 _1112 = vec3(0.0);
    vec3 _1113 = vec3(_543._m34.x, _543._m34.y, _543._m34.z);
    vec3 _1121 = vec3(_543._m34.w, _543._m35.x, _543._m35.y);
    vec3 _1129 = vec3(_543._m35.z, _543._m35.w, _543._m36.x);
    vec3 _1137 = vec3(_543._m36.y, _543._m36.z, _543._m36.w);
    vec3 _1145 = ((_1113 - (_1121 * _543._m6.y)) + (_1129 * _543._m6.z)) - (_1137 * _543._m6.x);
    float _1170 = _874._m27.x * _556._m5.x;
    _1112 += max(_1145 * _10(_1170), vec3(0.0));
    float _1182;
    if (dot(_543._m10, vec3(1.0)) > 0.0)
    {
        _1182 = -_543._m3;
    }
    else
    {
        _1182 = _543._m3;
    }
    _543._m3 = _1182;
    _543._m18 = _1112;
    float _1202 = dot(_543._m6, _543._m13);
    float _1196 = _10(_1202);
    vec3 _1206 = _543._m19;
    vec3 _1212 = _543._m6;
    vec3 _1215 = _543._m13;
    vec3 _1218 = _543._m13;
    vec3 _1221 = _543._m2;
    float _1224 = _543._m3;
    vec3 _1204 = (_16(_1206) * _1196) * _75(_1212, _1215, _1218, _1221, _1224);
    _543._m18 += _1204;
    vec3 _1243 = (_543._m18 * _543._m0) + _543._m10;
    _1235 = vec4(_1243.x, _1243.y, _1243.z, _1235.w);
    vec3 _1247 = _543._m6;
    bool _1250 = false;
    vec2 _1251 = _111(_1247, _1250);
    _1246 = vec4(_1251.x, _1251.y, _1246.z, _1246.w);
    float _1255 = _543._m2.x;
    float _1259 = _543._m2.y;
    float _1263 = _543._m2.z;
    float _1267 = _543._m3;
    _1254 = vec4(_48(_1255), _48(_1259), _48(_1263), _114(_1267));
    uint _1272 = uint((_874._m26.x > 0.0) ? 8 : 0);
    uint _1278 = uint(int(_1272 > 0u));
    _1278 |= 2u;
    float _1286 = _543._m0.x;
    float _1290 = _543._m0.y;
    float _1294 = _543._m0.z;
    _1285 = vec4(_48(_1286), _48(_1290), _48(_1294), float(_1278) / 255.0);
    vec3 _1309 = _1235.xyz + _874._m28.xyz;
    _1235 = vec4(_1309.x, _1309.y, _1309.z, _1235.w);
}

